<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 * Admin forms.
 *
 * @package HostCMS 6\Admin
 * @version 6.x
 * @author Hostmake LLC
 * @copyright © 2005-2012 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 */
abstract class Admin_Form_Action_Controller extends Core_Servant_Properties
{
	protected $_Admin_Form_Action = NULL;
	protected $_Admin_Form_Controller = NULL;

	/**
	 * Constructor.
	 */
	public function __construct(Admin_Form_Action_Model $oAdmin_Form_Action)
	{
		$this->_Admin_Form_Action = $oAdmin_Form_Action;

		if (is_null($this->_Admin_Form_Action->id))
		{
			throw new Core_Exception('Admin form action does not exist.');
		}

		parent::__construct();
	}

	public function controller(Admin_Form_Controller $controller)
	{
		$this->_Admin_Form_Controller = $controller;
		return $this;
	}

	protected $_children = array();

	// Связанные сущности с формой
	public function addEntity(Admin_Form_Entity $oAdmin_Form_Entity)
	{
		// Set link to controller
		$oAdmin_Form_Entity->controller($this);

		$this->_children[] = $oAdmin_Form_Entity;
		return $this;
	}

	protected $_content = NULL;
	protected $_message = NULL;

	public function getContent()
	{
		return $this->_content;
	}

	public function addContent($content)
	{
		$this->_content .= $content;
		return $this;
	}

	public function getMessage()
	{
		return $this->_message;
	}

	public function addMessage($message)
	{
		$this->_message .= $message;
		return $this;
	}

	protected $_object = NULL;

	public function setObject($object)
	{
		$this->_object = $object;
		return $this;
	}

	public function getObject()
	{
		return $this->_object;
	}

	protected $_datasetId = NULL;

	public function setDatasetId($datasetId)
	{
		$this->_datasetId = $datasetId;
		return $this;
	}

	public function getDatasetId()
	{
		return $this->_datasetId;
	}

	public function getName()
	{
		return $this->_Admin_Form_Action->name;
	}

	// При возврате TRUE выполнение следующих действий прерывается
	abstract public function execute($operation = NULL);
}
