<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 * Admin forms.
 * Типовой контроллер загрузки значений списка для <select>
 *
 * @package HostCMS 6\Admin
 * @version 6.x
 * @author Hostmake LLC
 * @copyright © 2005-2012 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 */
class Admin_Form_Action_Controller_Type_Load_Select_Options extends Admin_Form_Action_Controller
{
	protected $_conditions = array();
	protected $_model = NULL;

	protected $_defaultValue = NULL;

	public function defaultValue($defaultValue)
	{
		$this->_defaultValue = $defaultValue;
		return $this;
	}

	public function addCondition($condition)
	{
		$this->_conditions[] = $condition;
		return $this;
	}

	public function model($model)
	{
		$this->_model = $model;
		return $this;
	}

	/**
	 * Constructor.
	 */
	public function __construct(Admin_Form_Action_Model $oAdmin_Form_Action)
	{
		parent::__construct($oAdmin_Form_Action);
	}

	/**
	 * Executes the business logic.
	 */
	public function execute($operation = NULL)
	{
		if (is_null($this->_model))
		{
			throw new Core_Exception('model is NULL.');
		}

		$oObject = $this->_model;

		$queryBuilder = $oObject->queryBuilder();

		foreach ($this->_conditions as $condition)
		{
			list($operator, $args) = each($condition);
			call_user_func_array(array($queryBuilder, $operator), $args);
		}

		$aObjects = $oObject->findAll();

		$aArray = array();
		if (!is_null($this->_defaultValue))
		{
			$aArray[] = $this->_defaultValue;
		}

		foreach ($aObjects as $Object)
		{
			$aArray[$Object->id] = $Object->name;
		}

		echo json_encode($aArray);
		die();
	}
}