<?php

/**
 * Система управления сайтом HostCMS v. 5.xx
 *
 * Copyright © 2005-2011 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
*
* Класс модуля "CommerceML".
*
* Файл: /modules/shop/cml.class.php
*
* @author Hostmake LLC
* @version 5.x
*/
class cml
{
	var $nl2br;
	/**
	* Импорт из формата CommerceML
	* @param int $array_of_cml_data массив с данными в формате CommerceML, полученный в результате работы метода Xml2Array класса kernel, выполненного на целевом XML файле, содержащим данные в формате CommerceML
	* @param int $shop_shops_id идентификатор интернет-магазина
	* @param int $import_price_action_items идентификатор действия с уже существующими товарами (0 - Удалить существующие товары (во всех группах), 1 - Обновить информацию для существующих товаров, 2 - Оставить без изменений)
	* @param int $shop_groups_parent_id идентификатор группы в которую выгружать данные из CommerceML
	* @param str $images_path путь к картинкам
	* @return array ассоциативный массив с данными о количестве обработанных данных
	* - array['count_insert_item'] - количество вставленных товаров
	* - array['count_update_item'] - количество обновленных товаров
	* - array['count_dir'] - количество вставленных групп товаров
	*/
	function ImportCML($array_of_cml_data, $shop_shops_id, $import_price_action_items, $shop_groups_parent_id, $images_path = '', $nl2br = TRUE)
	{
		$this->nl2br = $nl2br;

		$count_insert_item = 0;

		$count_update_item = 0;

		$count_dir = 0;

		$shop = & singleton('shop');

		$row_shop = $shop->GetShop($shop_shops_id);

		$kernel = & singleton('kernel');

		$DataBase = & singleton('DataBase');

		$DateTime = & singleton('DateClass');

		$fRoznPrice_name = defined('SHOP_DEFAULT_CML_CURRENCY_NAME')
		?	SHOP_DEFAULT_CML_CURRENCY_NAME
		: 'Розничная';

		if($import_price_action_items == 0)
		{
			// Необходимо очистить магазин перед выгрузкой
			$shop->DeleteAllItemsCatalogAndGroups($shop_shops_id);
		}

		$array_of_type_of_prices_1v = array();
		$item_extra_properties_array = array();
		$item_base_properties_array = array();
		$item_extra_properties_values_array = array();


		$base_property_valid_assign = array("HOSTCMS_TITLE", "HOSTCMS_DESCRIPTION", "HOSTCMS_KEYWORDS", "HOSTCMS_МЕТКИ", "YANDEX_MARKET", "ПРОДАВЕЦ", "ПРОИЗВОДИТЕЛЬ", "АКТИВНОСТЬ");

		if (isset($array_of_cml_data['children'][0]))
		{
			$array_of_cml_data = $array_of_cml_data['children'][0];

			// Есть узел "КоммерческаяИнформация" и у нее есть хотя бы 1 ребенок
			if (isset($array_of_cml_data['name'])
			&& $array_of_cml_data['name'] == 'КоммерческаяИнформация'
			&& isset($array_of_cml_data['children']))
			{
				// Ищем дочерний узел с именем "Каталог"
				foreach ($array_of_cml_data['children'] as $number => $metadata)
				{
					// Вставки дерева групп для CML v. 2.0x
					if (isset($metadata['name'])
					&& $metadata['name'] == 'Классификатор' && isset($metadata['children']))
					{
						$count_dir += $shop->InsertTreeGroup($shop_groups_parent_id, $shop_shops_id, $metadata);

						// Список свойств
						foreach ($metadata['children'] as $property_nodes)
						{
							// Свойства
							if ($property_nodes['name'] == 'Свойства'
							&& isset($property_nodes['children'])
							&& count($property_nodes['children']) > 0)
							{
								foreach($property_nodes['children'] as $property_node)
								{
									if (isset($property_node['children']))
									{
										$property_id = false;
										$property_name = false;

										foreach ($property_node['children'] as $property_node_value)
										{
											if($property_node_value['name'] == 'Ид')
											{
												$property_id = $property_node_value['value'];
											}

											if($property_node_value['name'] == 'Наименование')
											{
												$property_name = $property_node_value['value'];
											}

											if(isset($property_node_value['children']))
											{
												foreach($property_node_value['children'] as $type_value)
												{
													if(isset($type_value['children']))
													{
														foreach($type_value['children'] as $value_info)
														{
															if(isset($value_info['children']))
															{
																foreach($value_info['children'] as $value_variant)
																{
																	if(isset($value_variant['children']))
																	{
																		$id = 0;

																		foreach($value_variant['children'] as $data)
																		{
																			if(Core_Type_Conversion::toStr($data['name']) == 'Ид')
																			{
																				$id = $data['value']; // пока нам неизвестно значение свойства
																			}
																			if(Core_Type_Conversion::toStr($data['name']) == 'Значение')
																			{
																				$item_extra_properties_values_array[$id] = $data['value'];
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}

										if($property_id && $property_name)
										{
											// Проверка, основное это свойство или дополнительное
											if(in_array(mb_strtoupper($property_name), $base_property_valid_assign) || mb_strpos(mb_strtoupper($property_name), "WAREHOUSE_") === 0)
											{
												// Основное свойство
												$item_base_properties_array[$property_id] = array('property_name' => $property_name, 'property_cml_value' => '');
											}
											else
											{
												// Дополнительное свойство
												$item_extra_properties_array[$property_id] = array('property_name' => $property_name, 'property_cml_value' => '');
												//$item_extra_properties_array[$property_id] = array('property_name' => $property_name, 'property_cml_value' => '');
											}
										}
									}
								}

								/* // Свойство
								foreach ($property_nodes['children'] as $property_node)
								{
									if (isset($property_node['children']))
									{
										$property_cml_id = false;
										$property_name = false;

										foreach ($property_node['children'] as $subnode)
										{
											switch ($subnode['name'])
											{
												case 'Ид':
													$property_cml_id = $subnode['value'];
													break;
												case 'Наименование':
													$property_name = $subnode['value'];
													break;
											}

											if(!isset($ItemPropertysValues))
											{
												$ItemPropertysValues = array();
											}

											$extra_property_cml_id = '';

											$extra_property_value = '';

											if(isset($subnode['children']))
											{
												foreach($subnode['children'] as $value_type)
												{
													if(isset($value_type['children']))
													{
														foreach($value_type['children'] as $ext_data)
														{
															if(isset($ext_data['name'])
															&& $ext_data['name'] == 'ВариантыЗначений'
															&& isset($ext_data['children']))
															{
																foreach($ext_data['children'] as $property_ext_add_data)
																{
																	if(isset($property_ext_add_data['children']))
																	{
																		foreach($property_ext_add_data['children'] as $property_ext_data)
																		{
																			if(Core_Type_Conversion::toStr($property_ext_data['name']) == 'Ид')
																			{
																				// CML_ID дополнительного свойства
																				$extra_property_cml_id = $property_ext_data['value'];
																			}

																			if(Core_Type_Conversion::toStr($property_ext_data['name']) == 'Значение')
																			{
																				// Значение дополнительного свойства
																				$extra_property_value = $property_ext_data['value'];
																			}

																			if($extra_property_cml_id != '' && $extra_property_value != '')
																			{
																				$ItemPropertysValues[$extra_property_cml_id] = $extra_property_value;

																				$extra_property_cml_id = '';
																				$extra_property_value = '';
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}

										if ($property_cml_id && $property_name)
										{
											if(stripos($property_name, "hostcms_") === false
											&& stripos($property_name, "warehouse_") === false
											&& $property_name != 'YANDEX_MARKET')
											{
												// Свойства нет
												if (!$shop->GetItemPropertyIdByCmlId($property_cml_id, $shop_shops_id))
												{
													// Вставляем св-во
													$shop->InsertPropretyOfItems(array(
													'shop_shops_id' => $shop_shops_id,
													'name' => $property_name,
													'shop_list_of_properties_cml_id' => $property_cml_id
													));
												}
											}
											else
											{
												$array_of_base_properties[$property_cml_id] = $property_name;
											}

										}
									}
								} */
							}
						}
					}



					if (isset($metadata['name'])
					&&
					($metadata['name'] == 'Каталог'
					|| $metadata['name'] == 'ПакетПредложений')
					&& isset($metadata['children']))
					{
						$new_group_array = array();
						$new_group_array_tree = array();
						// $temp_group_data = array();
						//

						// Строим дерево групп
						foreach ($metadata['children'] as $c_number => $c_metadata)
						{
							if ($c_metadata['name'] == 'Группа'
							&& isset($c_metadata['attr']))
							{
								// Для корня родитель не передается, поэтому положим равным 0
								if (!isset($c_metadata['attr']['Родитель']))
								{
									$c_metadata['attr']['Родитель'] = $shop->GenCmlId(0);
								}

								$new_group_array[$c_metadata['attr']['Идентификатор']] = $c_metadata['attr'];
								$new_group_array_tree[$c_metadata['attr']['Родитель']][] = $c_metadata['attr']['Идентификатор'];
							}
						}

						// Вначале в стэке только корневая группа
						$stack = array(0 => 0);

						// Текущая родительская группа
						$cur_parent_id = $shop_groups_parent_id;

						// Пока в стеке остаются элементы, продолжаем цикл
						while (count($stack) > 0)
						{
							// Текущая группа - последний элемент стека
							$end = end($stack);

							$current_group_cml_id = $shop->GenCmlId($end);

							// Удаляем элемент из стэка, т.к. мы извлекли из него все, что нужно
							unset($stack[count($stack) - 1]);

							// Пытаемся получить группу по ее CommerceML ID
							if ($parent_group_row = $shop->GetGroupIdByCmlId($current_group_cml_id, $shop_shops_id))
							{
								$cur_parent_id = $parent_group_row['shop_groups_id'];
							}

							//if (isset($new_group_array_tree[$end]))
							if (isset($new_group_array_tree[$current_group_cml_id]))
							{
								//foreach ($new_group_array_tree[$end] as $key => $group_cml_id)
								foreach ($new_group_array_tree[$current_group_cml_id] as $key => $group_cml_id)
								{
									// Проверяем, есть ли группа в базе с текущим $group_cml_id
									if (!$shop->GetGroupIdByCmlId($group_cml_id, $shop_shops_id))
									{
										// Если нет, получаем данные о группе
										$array_of_data = $new_group_array[$group_cml_id];

										// Формируем массив параметров для вставки
										$param = array();

										$param['shop_groups_name'] = $array_of_data['Наименование'];

										$param['shop_shops_id'] = $shop_shops_id;

										$param['shop_groups_parent_id'] = $cur_parent_id;
										$param['shop_groups_cml_id'] = $group_cml_id;

										$shop->InsertGroup($param);

										$count_dir++;
									}

									// [] нельзя, т.к. тогда индекс в массиве не будет сбрасываться
									$stack[count($stack)] = $group_cml_id;
								}
							}
						}

						reset($metadata['children']);

						$array_of_warehouses_cml_1v = array();

						// Работаем с дополнительными свойствами
						foreach ($metadata['children'] as $c_number => $c_metadata)
						{
							if ($c_metadata['name'] == 'Свойство'
							&& isset($c_metadata['attr']))
							{
								// Делаем поддержку складов для формата CommerceML 1.x
								$warehouse = & singleton('warehouse');

								if(mb_strpos(mb_strtoupper($c_metadata['attr']['Наименование']), "WAREHOUSE_") === 0)
								{
									// Получаем имя склада
									$warehouse_name = str_ireplace("WAREHOUSE_", "", $c_metadata['attr']['Наименование']);

									$warehouse_name = quote_smart($warehouse_name);

									// Ищем склад по имени
									$sql = "SELECT * FROM `shop_warehouse_table` WHERE `shop_warehouse_name`='$warehouse_name' AND `shop_shops_id`='$shop_shops_id'";

									$warehouse_result = $DataBase->query($sql);

									if($warehouse_result && mysql_num_rows($warehouse_result) > 0)
									{
										// Склад найден, берем его идентификатор
										$warehouse_row = mysql_fetch_assoc($warehouse_result);

										$warehouse_id = $warehouse_row['shop_warehouse_id'];
									}
									else
									{
										// Склад не найден, добавляем
										$warehouse_id = $warehouse->InsertWarehouse(array(
											'shop_shops_id' => $shop_shops_id,
											'shop_warehouse_name' => $warehouse_name,
											'shop_warehouse_activity' => 1,
											'shop_country_id' => 0,
											'shop_location_id' => 0,
											'shop_city_id' => 0,
											'shop_city_area_id' => 0,
											'shop_warehouse_address' => '',
											'shop_warehouse_order' => 0,
											'shop_warehouse_default' => 0
										));
									}

									/* // необходимо указать переданное количество ($property_value) товара на складе
									$warehouse->InsertWarehouseItems(array(
										'shop_warehouse_id' => $warehouse_id,
										'shop_items_catalog_item_id' => $item_row['shop_items_catalog_item_id'],
										'shop_warehouse_items_count' => $property_value
									)); */

									// Сохраняем значение идентифкатор склада для последующей привязки к товару
									$array_of_warehouses_cml_1v[$c_metadata['attr']['Идентификатор']] = $warehouse_id;
								}
								elseif($c_metadata['attr']['Наименование'] == 'Тип цены')
								{
									// Свойство "Тип цены"
									$array_of_type_of_prices_1v[$c_metadata['attr']['Идентификатор']] = $c_metadata['attr']['Наименование'];
								}
								elseif (!$shop->GetItemPropertyIdByCmlId($c_metadata['attr']['Идентификатор'], $shop_shops_id))
								{
									// Свойство не существует, добавляем его
									$shop->InsertPropretyOfItems(array(
									'name' => $c_metadata['attr']['Наименование'],
									'shop_list_of_properties_cml_id' => $c_metadata['attr']['Идентификатор'],
									'shop_shops_id' => $shop_shops_id));
								}
							}
						}

						reset($metadata['children']);

						// Работаем с товарами версии CML 1.x
						foreach ($metadata['children'] as $c_number => $c_metadata)
						{
							if ($c_metadata['name'] == 'Товар'
							&& isset($c_metadata['attr']))
							{
								$param = array();

								// Для корня родитель не передается, поэтому положим равным 0
								if (!isset($c_metadata['attr']['Родитель']))
								{
									$c_metadata['attr']['Родитель'] = 0;
								}

								if(isset($c_metadata['attr']['ИдентификаторВКаталоге']))
								{
									// Обнаружен артикул товара CML 1.x
									$param['marking'] = $c_metadata['attr']['ИдентификаторВКаталоге'];
								}

								// Ищем товар с таким же CML ID
								$exist_shop_item_row = $shop->GetCatalogItemIdByCmlId($c_metadata['attr']['Идентификатор'], $shop_shops_id);

								// Если "Оставить как есть" и есть информация в базе о товаре - не проводим вставку/обновление
								if (!($exist_shop_item_row && $import_price_action_items == 2))
								{
									// Получаем родительскую группу товара по идентификатору
									if ($c_metadata['attr']['Родитель'] == 'ID00000000')
									{
										$parent_group_data = -1;
									}
									else
									{
										$parent_group_data = $shop->GetGroupIdByCmlId($c_metadata['attr']['Родитель'], $shop_shops_id);

										// Группу в CML не нашли, кладем в корень
										if (!$parent_group_data)
										{
											$parent_group_data = -1;
										}
									}

									// Если нашли родительскую группу
									if ($parent_group_data
									|| $c_metadata['attr']['Родитель'] == 0)
									{


										$param['shop_items_cml_id'] = $c_metadata['attr']['Идентификатор'];

										if (isset($parent_group_data['shop_groups_id']))
										{
											$param['groups_id'] = $parent_group_data['shop_groups_id'];
										}
										elseif ($parent_group_data == -1)
										{
											$param['groups_id'] = 0;
										}
										else
										{
											$param['groups_id'] = $cur_parent_id;
										}

										if ($exist_shop_item_row)
										{
											// передаем идентификатор товара
											$param['item_id'] = $exist_shop_item_row['shop_items_catalog_item_id'];

											$count_update_item++;
										}
										else
										{
											$count_insert_item++;
										}

										$param['name'] = $c_metadata['attr']['Наименование'];

										if (isset($c_metadata['attr']['Единица']))
										{
											// Обрабатываем значение "Единица измерения"
											$mesure_data = $shop->GetMesuresByLike($c_metadata['attr']['Единица']);

											// Если такой единицы измерения нет, добавляем ее
											if (!$mesure_data)
											{
												$param['mesures_id'] = $shop->InsertMesure(array('name' => $c_metadata['attr']['Единица']));
											}
											else
											{
												$param['mesures_id'] = $mesure_data['shop_mesures_id'];
											}
										}
										else
										{
											// Иначе берем из атрибутов магазина
											$param['mesures_id'] = $row_shop['shop_mesures_id'];
										}

										$param['shops_id'] = $shop_shops_id;

										// Запрещаем событийную индексацию при импорте из CML
										$param['search_event_indexation'] = false;

										if(Core_Type_Conversion::toInt($param['item_id']) == 0)
										{
											$param['shop_items_catalog_date_time'] = date("Y-m-d H:i:s");
										}

										$shop->InsertItem($param);
									}
									// Если не нашли родительскую группу, выводим сообщение об ошибке
									else
									{
										// вывести сообщение об ошибке
										show_error_message(sprintf($GLOBALS['MSG_shops']['error_cant_find_parent_catalog'], $c_metadata['attr']['Родитель'], $c_metadata['attr']['Наименование']));
									}
								}

								// Обработка значений свойств для товара
								if (isset($c_metadata['children']))
								{
									$property_array = array();
									foreach ($c_metadata['children'] as $property_id => $property_data)
									{
										// Проверим, не склад ли это?
										if(isset($array_of_warehouses_cml_1v[$property_data['attr']['ИдентификаторСвойства']]))
										{
											// Это склад

											// Получаем данные товара
											$item_row = $shop->GetCatalogItemIdByCmlId($c_metadata['attr']['Идентификатор'], $shop_shops_id);

											// необходимо указать переданное количество ($property_value) товара на складе

											if($item_row)
											$warehouse->InsertWarehouseItems(array(
												'shop_warehouse_id' => $array_of_warehouses_cml_1v[$property_data['attr']['ИдентификаторСвойства']],
												'shop_items_catalog_item_id' => $item_row['shop_items_catalog_item_id'],
												'shop_warehouse_items_count' => $property_data['attr']['Значение']
											));
										}
										else
										{
											// это простое дополнительное свойство
											if (isset($property_data['name'])
											&& $property_data['name'] == 'ЗначениеСвойства')
											{
												if (isset($property_data['attr']['Значение']))
												{
													// Значения могут быть множественными, поэтому ниже мы им сделаем implode
													$property_array[$property_data['attr']['ИдентификаторСвойства']][] = $property_data['attr']['Значение'];
												}
											}

											if (count($property_array) > 0)
											{
												foreach ($property_array as $property_cml_id => $property_value_array)
												{
													$value_property = implode(', ', $property_value_array);

													$item_row = $shop->GetCatalogItemIdByCmlId($c_metadata['attr']['Идентификатор'], $shop_shops_id);

													// Импорт свойств с ID = 0 (описание и текст товара)
													if ($property_cml_id === 0)
													{
														$data_counter = 0;

														foreach ($c_metadata['children'] as $data_store_id => $data_store)
														{
															if ($data_store['attr']['ИдентификаторСвойства'] == 0)
															{
																if ($data_counter == 0)
																{
																	// Обновляем основное свойство "Описание"
																	$data_counter++;

																	$shop->InsertItem(
																	array('shops_id' => $shop_shops_id,
																	'item_id' => $item_row['shop_items_catalog_item_id'],
																	'description' => $data_store['attr']['Значение'],
																	'search_event_indexation' => false));
																}
																else
																{
																	// Обновляем основное свойство "Текст"
																	$data_counter = 0;

																	$shop->InsertItem(array('shops_id' => $shop_shops_id,
																	'item_id' => $item_row['shop_items_catalog_item_id'],
																	'text' => $data_store['attr']['Значение'],
																	'search_event_indexation' => false));
																}
															}
														}
													}

													// Если найден товар для дополнительного свойства
													if ($item_row)
													{
														// Исли найдено свойство для его значения
														if ($prop_row = $shop->GetItemPropertyIdByCmlId($shop->GenCmlId($property_cml_id), $shop_shops_id))
														{
															// Сохраняем значение свойства
															$shop->InsertPropertiesItem(
															array('shop_items_catalog_item_id' => $item_row['shop_items_catalog_item_id'],
															'shop_list_of_properties_id' => $prop_row['shop_list_of_properties_id'],
															'shop_properties_items_value' => $value_property));

															// Если дополнительное свойство не доступно группе товаров, включаем доступность данного свойства данной группе товаров
															if (!$shop->IssetPropertyForGroup(
															array('shop_groups_id' => $item_row['shop_groups_id'],
															'shop_list_of_properties_id' => $prop_row['shop_list_of_properties_id'],
															'shop_shops_id' => $shop_shops_id)))
															{
																$shop->InsertPropertyForGroup(array('shop_groups_id' => $item_row['shop_groups_id'], 'shop_list_of_properties_id' => $prop_row['shop_list_of_properties_id'], 'shop_shops_id' => $shop_shops_id));
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}

						// Работаем с товарами версии CML 2.x
						foreach ($metadata['children'] as $c_number_allitems => $c_metadata_allitems)
						{

							// ТипыЦен
							if ($c_metadata_allitems['name'] == 'ТипыЦен'
							&& isset($c_metadata_allitems['children']))
							{
								// Массив всех загруженных из CML ТипЦен
								// имеет структуру

								$aAllTax = array();

								foreach ($c_metadata_allitems['children'] as $c_number => $c_metadata)
								{
									if ($c_metadata['name'] == 'ТипЦены')
									{
										$aTax = array();

										if(isset($c_metadata['children']))
										{
											// Цикл по атрибутам цены
											foreach ($c_metadata['children'] as $c_metadata_currency)
											{
												// Информация о цене
												$aTax[$c_metadata_currency['name']] = $c_metadata_currency['value'];

												// Информация о налоге
												if (isset($c_metadata_currency['children']))
												{
													// Цикл по атрибутам цены
													foreach ($c_metadata_currency['children'] as $c_metadata_tax)
													{
														$aTax[$c_metadata_currency['name']][$c_metadata_tax['name']] = $c_metadata_tax['value'];
													}
												}
											}
										}

										// Пытаемся получить цену по CML ID
										if (isset($aTax['Ид'])
										// Нельзя, т.к. при вставке мы не узнаем, какя из них розничная
										&& mb_strtolower($aTax['Наименование']) != mb_strtolower($fRoznPrice_name)
										&& !$shop->GetPriceByCmlId($aTax['Ид'], $shop_shops_id))
										{
											$user_id = $kernel->GetCurrentUser();

											$shop->InsertPrice(array (
												'shop_shops_id' => $shop_shops_id,
												'name' => $aTax['Наименование'],
											// В CommerceML процент к базовой не передается, поэтому устанавливаем равной 100%
												'percent_to_basic' => '100',
											// В CommerceML группа пользователей не передается, поэтому устанавливаем равной 0
												'user_group_id' => 0,
												'shop_list_of_prices_cml_id' => $aTax['Ид'],
												'users_id' => $user_id
											));
										}

										if (isset($aTax['Ид']))
										{
											// Используется ниже при определении валюты товара и цены
											$aAllTax[$aTax['Ид']] = $aTax;

											// УБРАНО!
											//if (0)
											//{
											 // Налог по CML ID не найден - вставляем его

											 // Не нужно вставлять налог со ставкой равной 0, ибо это offers.xml
											 /* if (isset($aTax['Налог'])
												&& !$shop->GetTaxIdByCmlId($aTax['Налог']['Наименование']))
											 {
												$shop->InsertTax(array('shop_tax_name' => Core_Type_Conversion::toStr($aTax['Налог']['Наименование']),
												// В момент импорта ставка налога неизвестна
												'shop_tax_rate' => 0,
												'shop_tax_is_in_price' => ($aTax['Налог']['УчтеноВСумме'] == 'true') ? 1 : 0,
												'shop_tax_cml_id' => Core_Type_Conversion::toStr($aTax['Налог']['Наименование'])
												));
												} */

												if (isset($aTax['Налог']))
												{
													// Ищем налог по CML_ID
													if($tax_id = $shop->GetTaxIdByCmlId($aTax['Налог']['Наименование']))
													{
														// Нашли налог, необходимо обновить информацию о том, входит ли он в цену
														$shop->InsertTax(array(
														'shop_tax_is_in_price' => ($aTax['Налог']['УчтеноВСумме'] == 'true') ? 1 : 0,
														'shop_tax_id' => $tax_id
														));
													}
												}

											//}
										}
									}

								}
							}

							// Создаем массив для хранения специальных цен
							$special_prices_array = array();

							// Товары и Предложения имеют схожую структуру, при этом в Предложении содержится цена
							if (($c_metadata_allitems['name'] == 'Товары'
							|| $c_metadata_allitems['name'] == 'Предложения')
							&& isset($c_metadata_allitems['children']))
							{
								foreach ($c_metadata_allitems['children'] as $c_number => $c_metadata)
								{
									if ($c_metadata['name'] == 'Товар'
									|| $c_metadata['name'] == 'Предложение')
									{
										$param = array();
										$AllPrice = array();

										$ItemPropertys = array();

										// Ед. измерения вначале берем из атрибутов магазина
										//$param['mesures_id'] = $row_shop['shop_mesures_id'];

										// Нельзя, т.к. при импорте предложений нет ID группы и товары переходят в корень
										$param['shops_id'] = $shop_shops_id;

										if(isset($c_metadata['children']) && is_array($c_metadata['children']))
										{
											// Определяем количество картинок у одного товара
											$item_pictures_count = 0;

											// Цикл по атрибутам товара
											foreach ($c_metadata['children'] as $c_number_item => $c_metadata_item)
											{
												switch ($c_metadata_item['name'])
												{
													case 'Ид':

														// Если в CML_ID присутствует символ # значит товар - модификация, слева от символа # находится CML_ID основного товара, справа - CML_ID непосредственно данной модификации
														if(mb_strpos($c_metadata_item['value'], "#"))
														{
															$temp = explode("#", $c_metadata_item['value']);

															//$c_metadata_item['value'] = $temp[0];

															// Ищем модификацию среди существующих товаров
															$item_mod_res = $shop->GetItemByParam(array('shop_items_cml_id' => $temp[1], 'shop_shops_id' => $shop_shops_id));

															if($item_mod_res
															&& mysql_num_rows($item_mod_res) > 0)
															{
																$item_mod_row = mysql_fetch_assoc($item_mod_res);

																// Нашли модификацию
																$param['item_id'] = $item_mod_row['shop_items_catalog_item_id'];

																// Получаем информацию об основном товаре, для получения веса (Тикет 68455)
																$baseItemDataRow = $shop->GetItem($item_mod_row['shop_items_catalog_modification_id']);

																$param['weight'] = $baseItemDataRow['shop_items_catalog_weight'];

																$param['shop_items_cml_id'] = $temp[1];
															}
															else
															{
																// Ищем родительский товар
																$item_parent_row = $shop->GetCatalogItemIdByCmlId($temp[0], $shop_shops_id);

																if($item_parent_row)
																{
																	// Делаем текущий товар модификацией существующего основного товара
																	$param['shop_items_catalog_modification_id'] = $item_parent_row['shop_items_catalog_item_id'];

																	// Вес модификации равен весу основного товара (Тикет 68455)
																	$param['weight'] = $item_parent_row['shop_items_catalog_weight'];

																	$param['groups_id'] = 0;

																	//$c_metadata_item['value'] = $temp[1];
																	$param['shop_items_cml_id'] = $temp[1];
																}
																else
																{
																	// Не нашли родительский товар
																	//$param['shop_items_cml_id'] = $temp[0];
																	// Необходимо вставить родительский товар с именем модификации

																	$new_item_id = $shop->InsertItem(array(
																		'shops_id' => $shop_shops_id,
																		'groups_id' => 0,
																		'name' => 'Товар',
																		'shop_items_cml_id' => $temp[0]
																	));

																	$param['shop_items_catalog_modification_id'] = $new_item_id;

																	$param['shop_items_cml_id'] = $temp[1];
																}
															}
														}
														else
														{
															// Это не модификация
															$param['shop_items_cml_id'] = $c_metadata_item['value'];
														}



														break;

													case 'Количество':

														$param['rest'] = $c_metadata_item['value'];
														break;

													case 'СкидкиНаценки':

														if(isset($c_metadata_item['children']))
														{
															foreach($c_metadata_item['children'] as $c_metadata_item_data)
															{
																if(isset($c_metadata_item_data['name'])
																&& $c_metadata_item_data['name'] == 'СкидкаНаценка'
																&& isset($c_metadata_item_data['children']))
																{
																	foreach($c_metadata_item_data['children'] as $c_metadata_item_data_value)
																	{
																		$special_prices_array[] = $c_metadata_item_data_value;
																	}
																}
															}
														}

														break;

													case 'Наименование':

														// Если мы добавляли искусственно основной товар выше, ему необходимо дать имя модификации
														if(isset($new_item_id))
														{
															$c_metadata_item['value'] = quote_smart($c_metadata_item['value']);

															$sql = "UPDATE `shop_items_catalog_table` SET `shop_items_catalog_name`='{$c_metadata_item['value']}' WHERE `shop_items_catalog_item_id`='$new_item_id'";

															$DataBase->query($sql);
														}

														// По тикету 63030 код был закомментирован
														/* if(!isset($param['item_id']))
														{ */
															$param['name'] = $c_metadata_item['value'];
														//}
														break;

													case 'Описание':
														$param['description'] = $this->nl2br ? nl2br(html_entity_decode($c_metadata_item['value'], ENT_COMPAT, 'UTF-8')) : html_entity_decode($c_metadata_item['value'], ENT_COMPAT, 'UTF-8');
														/* $param['text'] = html_entity_decode($c_metadata_item['value'], ENT_COMPAT, 'UTF-8'); */
														break;

													case 'ОписаниеHTML':
														$param['text'] = html_entity_decode($c_metadata_item['value'], ENT_COMPAT, 'UTF-8');
														break;

													case 'Штрихкод':
													case 'Артикул':
														// Если поле еще не заполнено и идет импорт не пакета предложений
														// или пришел имено артикул (он важнее штрихкода)
														if (!isset($param['marking']) && $metadata['name'] != 'ПакетПредложений'
														|| $c_metadata_item['name'] == 'Артикул')
														{
															$param['marking'] = $c_metadata_item['value'];

															// Ищем основной товар с таким же артикулом и другим Ид
															// Если находим - то текущий товар становится его модификацией
															if (isset($param['shop_items_cml_id']))
															{
																if($param['marking'] != '')
																{
																	$rItemResource = $shop->GetItemByParam(array('shop_shops_id' => $shop_shops_id,
																	'shop_items_catalog_marking' => $param['marking'],
																	'shop_items_catalog_modification_id' => 0));

																	while ($aItemRow = mysql_fetch_assoc($rItemResource))
																	{
																		// Нашли товар с другим CML_ID
																		if ($aItemRow['shop_items_cml_id'] != $param['shop_items_cml_id']
																		&& (defined('ALLOW_USE_MARKING_TO_GENERATE_MODIFICATIONS')
																		&& ALLOW_USE_MARKING_TO_GENERATE_MODIFICATIONS))
																		{
																			// Делаем текущий товар модификацией существующего основного товара
																			$param['shop_items_catalog_modification_id'] = $aItemRow['shop_items_catalog_item_id'];
																			$param['groups_id'] = 0;
																		}
																	}
																}
															}
														}

														break;

													case 'Картинка':

														// Делаем массив двумерным, ибо картинок может быть больше одной для одного товара и потребуется хранить дополнительные данные для каждой картинки
														$param['catalog_image'][$item_pictures_count]['image_path'] = $c_metadata_item['value'];
														$param['catalog_image'][$item_pictures_count]['image_property_cml_id'] = Core_Type_Conversion::toStr($c_metadata_item['attr']['Описание']);
														$item_pictures_count++;


														break;

													case 'ЗначенияСвойств':
													case 'ХарактеристикиТовара':
														if (isset($c_metadata_item['children']))
														{
															foreach ($c_metadata_item['children'] as $c_metadata_property)
															{
																if ($c_metadata_property['name'] == 'ЗначенияСвойства' || $c_metadata_property['name'] == 'ХарактеристикаТовара')
																{
																	if (isset($c_metadata_property['children']))
																	{
																		$property_cml_id = false;

																		$property_cml_value_id = false;

																		$property_cml_value = false;

																		foreach ($c_metadata_property['children'] as $c_metadata_property_addition_data)
																		{
																			switch ($c_metadata_property_addition_data['name'])
																			{
																				case 'Ид': // ID свойства
																				case 'Наименование':
																				$property_cml_id = $c_metadata_property_addition_data['value'];
																				break;
																				case 'Значение':
																				$property_cml_value = $c_metadata_property_addition_data['value'];
																				break;
																				case 'ИдЗначения':
																				$property_cml_value_id = $c_metadata_property_addition_data['value'];
																				break;
																			}
																			/* switch ($c_metadata_property_addition_data['name'])
																			{
																				case 'Ид':
																				case 'Наименование':
																					$property_cml_id = $c_metadata_property_addition_data['value'];
																					break;
																				case 'Значение':
																					$property_value = $c_metadata_property_addition_data['value'];
																					break;
																				case 'ИдЗначения':
																					$property_cml_value_id = $c_metadata_property_addition_data['value'];
																					break;
																			}



																			if ($property_cml_id && isset($property_value))
																			{
																				$ItemPropertys[$property_cml_id] = $property_value;
																			}

																			if(isset($ItemPropertysValues)
																			&& $property_cml_value_id
																			&& $property_cml_id
																			&& isset($ItemPropertys[$property_cml_id])
																			&& isset($ItemPropertysValues[$property_cml_value_id]))
																			{
																				$ItemPropertys[$property_cml_id] = $ItemPropertysValues[$property_cml_value_id];
																			} */
																		}

																		if($property_cml_id)
																		{
																			if($property_cml_value || $property_cml_value == '')
																			{
																				// Передан идентификатор свойства и значение
																				if(isset($item_extra_properties_array[$property_cml_id]))
																				{
																					$item_extra_properties_array[$property_cml_id] =  array('property_cml_value' => $property_cml_value, 'property_name' => $item_extra_properties_array[$property_cml_id]['property_name']);
																				}
																				elseif(isset($item_base_properties_array[$property_cml_id]))
																				{
																					$item_base_properties_array[$property_cml_id] = array('property_cml_value' => $property_cml_value, 'property_name' => $item_base_properties_array[$property_cml_id]['property_name']);
																				}

																				unset($property_cml_value);
																			}

																			if($property_cml_value_id)
																			{
																				if(isset($item_extra_properties_array[$property_cml_id]))
																				{
																					$item_extra_properties_array[$property_cml_id] =
																					array('property_cml_value' => $item_extra_properties_values_array[$property_cml_value_id], 'property_name' => $item_extra_properties_array[$property_cml_id]['property_name']);
																				}
																				elseif(isset($item_base_properties_array[$property_cml_id]))
																				{
																					$item_base_properties_array[$property_cml_id] = array('property_cml_value' => $item_extra_properties_values_array[$property_cml_value_id], 'property_name' => $item_base_properties_array[$property_cml_id]['property_name']);
																				}

																				unset($property_cml_value_id);
																			}

																			unset($property_cml_id);
																		}
																	}
																}
															}
														}
														break;

													case 'БазоваяЕдиница':
														// Дочерние элементы не всегда есть, получаем идентификатор единицы измерения по ее имени
														$mesure_data = $shop->GetMesuresByLike(trim($c_metadata_item['value']));

														// Если такой единицы измерения нет, добавляем ее
														if (!$mesure_data)
														{
															$param['mesures_id'] = $shop->InsertMesure(array('name' => trim($c_metadata_item['value'])));
														}
														else
														{
															$param['mesures_id'] = $mesure_data['shop_mesures_id'];
														}

														// Если есть дочерние
														if (isset($c_metadata_item['children'][0]['children']))
														{
															foreach ($c_metadata_item['children'][0]['children'] as $c_metadata_baseunit)
															{
																if ($c_metadata_baseunit['name'] == 'Единица')
																{
																	// Обрабатываем значение "Единица измерения"
																	$mesure_data = $shop->GetMesuresByLike(trim($c_metadata_baseunit['value']));

																	// Если такой единицы измерения нет, добавляем ее
																	if (!$mesure_data)
																	{
																		$param['mesures_id'] = $shop->InsertMesure(array('name' => trim($c_metadata_baseunit['value'])));
																	}
																	else
																	{
																		$param['mesures_id'] = $mesure_data['shop_mesures_id'];
																	}
																}

																// ДополнительныеДанные
																if ($c_metadata_baseunit['name'] == 'ДополнительныеДанные')
																{
																	if (isset($c_metadata_baseunit['children']))
																	{
																		foreach ($c_metadata_baseunit['children'] as $c_metadata_baseuniut_addition_data)
																		{
																			if (isset($c_metadata_baseuniut_addition_data['children']))
																			{
																				$aTmp = array();

																				foreach ($c_metadata_baseuniut_addition_data['children'] as $c_metadata_baseuniut_addition_data_item)
																				{
																					// Определение идет по value, т.к. в name строка "Наименование".
																					switch ($c_metadata_baseuniut_addition_data_item['name'])
																					{
																						case 'Наименование':
																							$aTmp['name'] = $c_metadata_baseuniut_addition_data_item['value'];
																							break;
																						case 'Значение':
																							$aTmp['value'] = $c_metadata_baseuniut_addition_data_item['value'];
																							break;
																					}
																				}

																				if (isset($aTmp['name']) && $aTmp['name'] == 'Вес')
																				{
																					$param['weight'] = $aTmp['value'];
																				}
																			}
																		}
																	}
																}
															}
														}
														break;

													case 'Группы':
														if (isset($c_metadata_item['children']))
														{
															foreach ($c_metadata_item['children'] as $c_metadata_group)
															{
																if ($c_metadata_group['name'] == 'Ид')
																{
																	if($c_metadata_group['value'] == 'ID00000000')
																	{
																		$parent_group_data = array('shop_groups_id' => 0);
																	}
																	else
																	{
																		$parent_group_data = $shop->GetGroupIdByCmlId($c_metadata_group['value'], $shop_shops_id);
																	}


																	if (isset($parent_group_data['shop_groups_id']))
																	{
																		$param['groups_id'] = $parent_group_data['shop_groups_id'];

																		if(isset($new_item_id))
																		{
																			// Необходимо прописать группу искусственно созданному товару выше
																			$sql = "UPDATE `shop_items_catalog_table`
																			SET `shop_groups_id`='{$parent_group_data['shop_groups_id']}'
																			WHERE `shop_items_catalog_item_id`='$new_item_id'";

																			$DataBase->query($sql);
																		}
																	}
																	// Если не нашли родительскую группу, выводим сообщение об ошибке
																	else
																	{
																		// вывести сообщение об ошибке
																		show_error_message(sprintf($GLOBALS['MSG_shops']['error_cant_find_parent_catalog'], $c_metadata_group['value'], Core_Type_Conversion::toStr($param['name'])));
																	}
																}
															}
														}
														break;

													case 'СтавкиНалогов':
														if (isset($c_metadata_item['children']))
														{
															// Используется при проверке соответствия ставки налога
															// ранее вставленного налога (где ставка еще была неопределена и равна 0)
															$aItemTax = array();

															foreach ($c_metadata_item['children'] as $c_metadata_itemtax)
															{
																if ($c_metadata_itemtax['name'] == 'СтавкаНалога')
																{
																	$aItemTaxTmp = array();

																	foreach ($c_metadata_itemtax['children'] as $c_metadata_itemtax_value)
																	{
																		// Определение идет по value, т.к. в name строка "Наименование".
																		switch ($c_metadata_itemtax_value['name'])
																		{
																			case 'Наименование':
																				$aItemTaxTmp['name'] = $c_metadata_itemtax_value['value'];
																				break;
																			case 'Ставка':
																				$aItemTaxTmp['value'] = $c_metadata_itemtax_value['value'];
																				break;
																		}

																		// Ищем налог в базе
																		if(isset($aItemTaxTmp['name'])
																		&& isset($aItemTaxTmp['value']))
																		{
																			if(!$findTax = $shop->GetTaxIdByCmlId($aItemTaxTmp['name'], $aItemTaxTmp['value']))
																			{
																				// Налог не найден, вставляем его
																				$item_tax_id = $shop->InsertTax(array(
																				'shop_tax_name' => $aItemTaxTmp['name'],
																				'shop_tax_rate' => $aItemTaxTmp['value'],
																				'shop_tax_is_in_price' => 0,
																				'shop_tax_cml_id' => $aItemTaxTmp['name']
																			));
																			}
																			else
																			{
																				$item_tax_id = $findTax['shop_tax_id'];
																			}

																			// Указываем товару его налог
																			$param['tax_id'] = $item_tax_id;
																		}

																		/* // Необходимо найти налог в базе по CML ID
																		$findTax = $shop->GetTaxIdByCmlId($aItemTaxTmp['name']);

																		if($findTax && isset($aItemTaxTmp['value']))
																		{
																			$findTax['shop_tax_rate'] = $aItemTaxTmp['value'];
																			$shop->InsertTax($findTax);
																		}
																		elseif(isset($aItemTaxTmp['value']))
																		{
																			// Необходимо вставить информацию о налоге в БД, в файле "Каталог" содержится информация о названии налога и ставке, в файле "ПакетПредложений" находится информация о том, входит ли налог в цену
																			$shop->InsertTax(array(
																			'shop_tax_name' => $aItemTaxTmp['name'],
																			'shop_tax_rate' => $aItemTaxTmp['value'],
																			'shop_tax_is_in_price' => 0,
																			'shop_tax_cml_id' => $aItemTaxTmp['name']
																			));
																		} */

																	}

																	$aItemTax[$aItemTaxTmp['name']] = $aItemTaxTmp;
																}
															}
														}
														break;

													case 'ЗначенияРеквизитов':
														if (isset($c_metadata_item['children']))
														{
															foreach ($c_metadata_item['children'] as $c_metadata_attributes_value)
															{
																$aTmp = array();

																if(isset($c_metadata_attributes_value['children']) && is_array($c_metadata_attributes_value['children']) && count($c_metadata_attributes_value['children']) > 0)
																{
																	foreach ($c_metadata_attributes_value['children'] as $c_metadata_attributes_value_item)
																	{
																		// Определение идет по value, т.к. в name строка "Наименование".
																		switch ($c_metadata_attributes_value_item['name'])
																		{
																			case 'Наименование':
																				$aTmp['name'] = $c_metadata_attributes_value_item['value'];
																				break;
																			case 'Значение':
																				$aTmp['value'] = $c_metadata_attributes_value_item['value'];
																				break;
																		}
																	}
																}

																if (isset($aTmp['name']))
																{
																	switch ($aTmp['name'])
																	{
																		case 'НаименованиеКраткое':
																			if (!isset($param['description']))
																			{
																				$param['description'] = Core_Type_Conversion::toStr($aTmp['value']);
																			}
																			break;
																		case 'НаименованиеПолное':
																			if (!isset($param['text']))
																			{
																				$param['text'] = Core_Type_Conversion::toStr($aTmp['value']);
																			}
																			break;
																		case 'Вес':
																			if (!isset($param['weight']))
																			{
																				$param['weight'] = Core_Type_Conversion::toStr($aTmp['value']);
																			}
																			break;
																	}
																}
															}
														}
														break;

													case 'Цены':
														if (isset($c_metadata_item['children']))
														{
															// Товар может содержать множество цен,
															// в качестве основной мы устанавливаем цену с названием "Розничная"

															// Цена меняется на $fRoznPrice, если розничной цены не было
															$fRoznPrice = false;
															$iRoznCurrencyId = false;

															foreach ($c_metadata_item['children'] as $c_metadata_prices)
															{
																if ($c_metadata_prices['name'] == 'Цена')
																{
																	$aPrice = array();

																	if(isset($c_metadata_prices['children']))
																	{
																		foreach ($c_metadata_prices['children'] as $c_metadata_prices_value)
																		{
																			$aPrice[$c_metadata_prices_value['name']] = $c_metadata_prices_value['value'];
																		}

																		// Устанавливаем цену и валюту товара
																		if (isset($aPrice['ИдТипаЦены']))
																		{
																			if (isset($aAllTax[$aPrice['ИдТипаЦены']]['Налог']['Наименование'])
																			&& isset($aItemTax[$aAllTax[$aPrice['ИдТипаЦены']]['Налог']['Наименование']]['value']))
																			{
																				$tax_value = intval($aItemTax[$aAllTax[$aPrice['ИдТипаЦены']]['Налог']['Наименование']]['value']);

																				// Определяем по CML ID и ставке
																				$aCurrentTax = $shop->GetTaxIdByCmlId($aPrice['ИдТипаЦены'], $tax_value);

																				// Налог по CML ID не найден - вставляем его
																				if (!$aCurrentTax)
																				{
																					$tax_id = $shop->InsertTax(array('shop_tax_name' => sprintf($GLOBALS['MSG_shops']['import_price_list_cml_insert_tax_mask'], Core_Type_Conversion::toStr($aTax['Наименование']), $tax_value),
																					// В момент импорта ставка налога неизвестна
																					'shop_tax_rate' => $tax_value,
																					'shop_tax_is_in_price' => ($aTax['Налог']['УчтеноВСумме'] == 'true') ? 1 : 0,
																					'shop_tax_cml_id' => Core_Type_Conversion::toStr($aTax['Ид'])
																					));
																				}
																				else
																				{
																					$tax_id = $aCurrentTax['shop_tax_id'];
																				}

																				// Налог
																				$param['tax_id'] = $tax_id;
																			}

																			if(isset($aPrice['ЦенаЗаЕдиницу']))
																			{
																				$fRoznPrice = $shop->ConvertPrice($aPrice['ЦенаЗаЕдиницу']);
																			}

																			if(isset($aPrice['Валюта']))
																			{
																				// Определяем валюту
																				$aCurrencyRow = $shop->GetCurrencyByLike($aPrice['Валюта']);
																			}

																			if ($aCurrencyRow)
																			{
																				$iRoznCurrencyId = $aCurrencyRow['shop_currency_id'];
																			}
																			else
																			{
																				// Вставляем валюту
																				$iRoznCurrencyId = $shop->InsertCurrency(array('name' => $aPrice['Валюта']));
																			}

																			// Если цена розничкая
																			if (isset($aAllTax[$aPrice['ИдТипаЦены']])
																			&& mb_strtolower($aAllTax[$aPrice['ИдТипаЦены']]['Наименование']) == mb_strtolower($fRoznPrice_name))
																			{
																				// Цена
																				$param['price'] = $fRoznPrice;

																				// Валюта
																				$param['currency_id'] = $iRoznCurrencyId;
																			}

																			// Получаем цену по CML ID
																			$aPriceByCmlId = $shop->GetPriceByCmlId($aPrice['ИдТипаЦены'], $shop_shops_id);

																			if ($aPriceByCmlId)
																			{
																				// Массив дополнительных цен, вставка/обновление ведется
																				// после вставки/обновления данных о товаре
																				$AllPrice[$aPriceByCmlId['shop_list_of_prices_id']] = array(
																				'price' => $fRoznPrice,
																				'currency_id' => $iRoznCurrencyId);
																			}
																		}
																	}
																}
															}

															// Если цены "Розничная" не было, устаналвиваем последнюю из списка цен
															if (!isset($param['price']))
															{
																$param['price'] = $fRoznPrice;
																$param['currency_id'] = $iRoznCurrencyId;
															}
														}
														break;
												}
											}
										}

										if(isset($new_item_id))
										{
											unset($new_item_id);
										}

										if (isset($param['shop_items_cml_id']))
										{
											// Ищем товар с таким же CML ID
											$exist_shop_item_row = $shop->GetCatalogItemIdByCmlId($param['shop_items_cml_id'], $shop_shops_id);

											// Если "Оставить как есть" и есть информация в базе о товаре - не проводим вставку/обновление
											//if (!($exist_shop_item_row && $import_price_action_items == 2))
											if (!($exist_shop_item_row && $import_price_action_items == 2))
											{
												if ($exist_shop_item_row)
												{
													// передаем идентификатор товара
													$param['item_id'] = $exist_shop_item_row['shop_items_catalog_item_id'];

													$count_update_item++;
												}
												else
												{
													$count_insert_item++;
												}

												// Запрещаем событийную индексацию при импорте из CML
												$param['search_event_indexation'] = false;

												if(Core_Type_Conversion::toInt($param['item_id']) == 0
												// Добавлено по тикету 67672
												|| $import_price_action_items == 1
												)
												{
													$param['shop_items_catalog_date_time'] = date("Y-m-d H:i:s");
												}


												if(isset($param['rest']))
												{
													$rest = Core_Type_Conversion::toFloat($param['rest']);
													unset($param['rest']);
												}

												$iNewItemId = $shop->InsertItem($param);

												// Необходимо вставить остаток на склад по умолчанию
												$warehouse = & singleton('warehouse');

												// Получаем склад по умолчанию
												$warehouse_row = $warehouse->GetDefaultWarehouse($shop_shops_id);

												if($warehouse_row && isset($rest))
												{
													$warehouse->InsertWarehouseItems(array(
														'shop_warehouse_id' => $warehouse_row['shop_warehouse_id'],
														'shop_items_catalog_item_id' => $iNewItemId,
														'shop_warehouse_items_count' => $rest
													));

													unset($rest);
												}

												$special_price_insert_array = array();

												$case = '';

												$case_percent = '';

												$case_date = '';

												$case_value = '';

												if($special_prices_array)
												{
													$price_array = array();
													$price_array['name'] = "Скидка";
													// вставка специальных цен....
													foreach($special_prices_array as $special_price_data)
													{
														switch($special_price_data['name'])
														{
															case 'Процент':

																$price_array['percent'] = $special_price_data['value'];
																$price_array['name'] = "Скидка {$price_array['percent']}%";

															break;
															case 'ДатаОкончания':

																$price_array['to'] = $special_price_data['value'];
																$price_array['name'] = "Скидка {$price_array['to']}%";

															break;

															default:
															break;
														}
													}

													// Получили необходимую информацию о скидке
													$sql = "SELECT * FROM `shop_discount_table`
													WHERE `shop_shops_id` = '$shop_shops_id'
													AND `shop_discount_percent` = '$case_percent'";

													$result = $DataBase->query($sql);

													// Добавляем сервисную информацию

													$price_array['from'] = date("Y-m-d H:i:s");
													$price_array['is_active'] = 1;
													$price_array['from'] = date("Y-m-d H:i:s");
													$price_array['users_id'] = false;
													$price_array['shop_shops_id'] = $shop_shops_id;

													if($result && mysql_num_rows($result) == 0)
													{
														// Таких скидок нет, добавляем
														$discount_id = $shop->InsertDiscount($price_array);
													}
													else
													{
														// Скидка есть, получаем ее идентификатор
														$discount_row = mysql_fetch_assoc($result);

														$discount_id = $discount_row['shop_discount_id'];
													}

													// Добавляем скидку товару
													$shop->InsertItemDiscount(array(
														'item_catalog_id' => $iNewItemId,
														'shop_discount_id' => $discount_id
													));

												}

												$special_prices_array = array();

												if ($iNewItemId)
												{
													// Есть доп. цены для товара
													if (count($AllPrice) > 0)
													{
														// вставляем их
														foreach ($AllPrice as $shop_list_of_prices_id => $aTmpArray)
														{
															// Пересчитываем валюту доп. цен в валюту товара (если необходимо)
															if ($aTmpArray['currency_id'] != $param['currency_id'])
															{
																$price_value = $aTmpArray['price'] * $shop->GetCurrencyCoefficientToShopCurrency($aTmpArray['currency_id'], $param['currency_id']);
															}
															else
															{
																$price_value = $aTmpArray['price'];
															}

															$shop->InsertPricesToItem(array('shop_items_catalog_item_id' => $iNewItemId,
															'shop_list_of_prices_id' => $shop_list_of_prices_id,
															'shop_prices_to_item_value' => $price_value));
														}
													}

													$new_item_name = '';

													$new_item_name_array = array();

													if (count($item_base_properties_array) > 0)
													{
														foreach ($item_base_properties_array as $property_cml_id => $data)
														{
															$property_name = $data['property_name'];
															$property_value = $data['property_cml_value'];

															if($property_value == '')
															{
																continue;
															}

															switch(mb_strtoupper($property_name))
															{
																case "HOSTCMS_TITLE":

																	// Необходимо добавить описание слова к товару
																	$shop->InsertItem(
																		array(
																		'item_id' => $iNewItemId,
																		'shops_id' => $shop_shops_id,
																		'seo_title' => $property_value,
																		'search_event_indexation' => false
																		)
																	);

																break;
																case "HOSTCMS_DESCRIPTION":

																	// Необходимо добавить описание слова к товару
																	$shop->InsertItem(
																		array(
																		'item_id' => $iNewItemId,
																		'shops_id' => $shop_shops_id,
																		'seo_description' => $property_value,
																		'search_event_indexation' => false
																		)
																	);

																break;
																case "HOSTCMS_KEYWORDS":

																	// Необходимо добавить ключевые слова к товару
																	$shop->InsertItem(
																		array(
																		'item_id' => $iNewItemId,
																		'shops_id' => $shop_shops_id,
																		'seo_keywords' => $property_value,
																		'search_event_indexation' => false
																		)
																	);

																break;
																case "HOSTCMS_МЕТКИ":

																	// Необходимо добавить тэги к товару
																	$shop->InsertItemsCatalogTags(array (
																		'tags' => $property_value,
																		'shop_items_catalog_item_id' => $iNewItemId
																	));
																break;

																case "YANDEX_MARKET":

																// Свойство с названием YANDEX_MARKET идет как основное свойство товара, отвечающее за флаг "Экспортировать в Яндекс.Маркет"
																$shop->InsertItem(
																	array(
																	'item_id' => $iNewItemId,
																	'shops_id' => $shop_shops_id,
																	'shop_items_catalog_yandex_market_allow' => Core_Type_Conversion::toInt($property_value),
																	'search_event_indexation' => false
																	)
																);

																break;

																case "ПРОДАВЕЦ":

																// Дополнительное св-во с названием "ПРОДАВЕЦ" импортируем как основное свойство "Продавец" текущего товара

																// Необходимо проверить, существует ли продавец с таким наименованием в базе данных

																$saller_row = $shop->GetSellerByName($property_value, $shop_shops_id);

																if($saller_row)
																{
																	// Продавец обнаружен
																	$saller_id = $saller_row[0]['shop_sallers_id'];
																}
																else
																{
																	// Продавец не обнаружен, необходимо добавить продавца с таким наименованием в базу
																	 $saller_id = $shop->InsertSeller(array(
																	 'shop_sallers_name' => $property_value,
																	 'shop_shops_id' => $shop_shops_id
																	 ));
																}

																// Ассоциируем продавца с товаром
																$shop->InsertItem(
																	array(
																	'item_id' => $iNewItemId,
																	'shops_id' => $shop_shops_id,
																	'shop_sallers_id' => $saller_id,
																	'search_event_indexation' => false
																	)
																);

																break;


																case "ПРОИЗВОДИТЕЛЬ":

																// Дополнительное свойство под названием "ПРОИЗВОДИТЕЛЬ" импортируем как производителя текущего товара

																// Ищем данного производителя среди производителей системы
																$produders_array = $shop->GetProducerByName($property_value, $shop_shops_id);

																if($produders_array)
																{
																	// Производитель обнаружен, ассоциируем его с текущем товаром
																	$producer_id = $produders_array[0]['shop_producers_list_id'];
																}
																else
																{
																	// Производитель не обнаружен, необходимо добавить его и ассоциировать с текущим товаром
																	$producer_id = $shop->InsertProducer(
																		array(
																		'shops_id' => $shop_shops_id,
																		'name' => $property_value
																		)
																	);
																}

																$shop->InsertItem(
																	array(
																	'item_id' => $iNewItemId,
																	'shops_id' => $shop_shops_id,
																	'producers_list_id' => $producer_id,
																	'search_event_indexation' => false
																	)
																);

																break;

																case "АКТИВНОСТЬ":

																if($property_value == "Да")
																{
																	$property_value = 1;
																}
																else
																{
																	$property_value = intval($property_value);

																	// Может быть 0 или 1
																	if ($property_value != 0)
																	{
																		$property_value = 1;
																	}
																}

																// Дополнительное свойство под названием "АКТИВНОСТЬ" импортируем как активность текущего товара

																$shop->InsertItem(
																	array(
																	//'item_id' => $item_row['shop_items_catalog_item_id'],
																	'item_id' => $iNewItemId,
																	'shops_id' => $shop_shops_id,
																	'is_active' => $property_value,
																	'search_event_indexation' => false
																	)
																);

																break;

																default:

																	// Ничего не найдено, быть может это склады?

																	if(mb_strpos(mb_strtoupper($property_name), "WAREHOUSE_") === 0)
																	{
																		// Получаем имя склада
																		$warehouse_name = str_ireplace("WAREHOUSE_", "", $property_name);

																		$warehouse_name = quote_smart($warehouse_name);

																		// Ищем склад по имени
																		$sql = "SELECT * FROM `shop_warehouse_table` WHERE `shop_warehouse_name`='$warehouse_name' AND `shop_shops_id`='$shop_shops_id'";

																		$warehouse_result = $DataBase->query($sql);

																		if($warehouse_result && mysql_num_rows($warehouse_result) > 0)
																		{
																			// Склад найден, берем его идентификатор
																			$warehouse_row = mysql_fetch_assoc($warehouse_result);

																			$warehouse_id = $warehouse_row['shop_warehouse_id'];
																		}
																		else
																		{
																			// Склад не найден, добавляем
																			$warehouse_id = $warehouse->InsertWarehouse(array(
																				'shop_shops_id' => $shop_shops_id,
																				'shop_warehouse_name' => $warehouse_name,
																				'shop_warehouse_activity' => 1,
																				'shop_country_id' => 0,
																				'shop_location_id' => 0,
																				'shop_city_id' => 0,
																				'shop_city_area_id' => 0,
																				'shop_warehouse_address' => '',
																				'shop_warehouse_order' => 0,
																				'shop_warehouse_default' => 0
																			));
																		}

																		// необходимо указать переданное количество ($property_value) товара на складе
																		$warehouse->InsertWarehouseItems(array(
																			'shop_warehouse_id' => $warehouse_id,
																			'shop_items_catalog_item_id' => $iNewItemId,
																			'shop_warehouse_items_count' => $property_value
																		));
																	}

																break;
															}

															$item_base_properties_array[$property_cml_id]['property_name'] = $property_name;
															$item_base_properties_array[$property_cml_id]['property_cml_value'] = "";
														}
													}

													if (count($item_extra_properties_array) > 0)
													{
														foreach ($item_extra_properties_array as $property_cml_id => $property_value)
														{
															$property_name = $property_value['property_name'];
															$property_value = $property_value['property_cml_value'];

															// Проверяем, есть ли в базе свойство с текущим $property_cml_id
															$prop_row = $shop->GetItemPropertyIdByCmlId($property_cml_id, $shop_shops_id);

															// Если свойства нет, и оно не входит в перечень основных свойств
															if (!$prop_row)
															{

																 // Вставляем доп. св-во товара
																$shop->InsertPropretyOfItems(array(
																'shop_shops_id' => $shop_shops_id,
																'name' => $property_name,
																'shop_list_of_properties_cml_id' => $property_cml_id
																));

																// Получаем вставленное св-во по CML-ID
																$prop_row = $shop->GetItemPropertyIdByCmlId($property_cml_id, $shop_shops_id);
															}

															// Получаем товар
															$item_row = $shop->GetItem($iNewItemId);

															// Если найден товар для дополнительного свойства
															if ($item_row && $prop_row)
															{

																// Если тип дополнительного свойства - Список, ищем переданное значение дополнительного свойства среди существующих значений Списка, если его там нет, необходимо его добавить
																if(Core_Type_Conversion::toInt($prop_row['shop_list_of_properties_type']) == 2 && class_exists('lists'))
																{
																	$list = & singleton('lists');

																	$property_item_id = $list->GetListItemIfIssetValue($prop_row['lists_id'], $property_value);

																	if($property_item_id)
																	{
																		$property_item_value = $property_item_id['lists_items_id'];
																	}
																	else
																	{
																		$property_item_value = false;
																	}

																	if(!$property_item_value)
																	{
																		$param = array();

																		// Необходимо добавить новое значение списка
																		$param['lists_id'] = $prop_row['lists_id'];
																		$param['lists_items_value'] = $property_value;
																		$param['lists_items_order'] = 0;
																		$param['lists_items_description'] = '';
																		$property_item_id = $list->InsertListItem($param);
																		$property_item_value = $property_item_id['lists_items_id'];
																	}
																}
																else
																{
																	$property_item_value = html_entity_decode($property_value, ENT_COMPAT, 'UTF-8');
																}

																 // Сохраняем значение свойства
																$shop->InsertPropertiesItem(
																array('shop_items_catalog_item_id' => $item_row['shop_items_catalog_item_id'],
																'shop_list_of_properties_id' => $prop_row['shop_list_of_properties_id'],
																'shop_properties_items_value' => $property_item_value));

																// Если дополнительное свойство не доступно группе товаров, включаем доступность данного свойства данной группе товаров
																if (!$shop->IssetPropertyForGroup(
																array('shop_groups_id' => $item_row['shop_groups_id'],
																'shop_list_of_properties_id' => $prop_row['shop_list_of_properties_id'],
																'shop_shops_id' => $shop_shops_id)))
																{
																	$shop->InsertPropertyForGroup(array('shop_groups_id' => $item_row['shop_groups_id'], 'shop_list_of_properties_id' => $prop_row['shop_list_of_properties_id'], 'shop_shops_id' => $shop_shops_id));
																}

																// Проверяем, если товар - модификация, необходимо добавить к имени товара все дополнительные свойства в формате Свойство Значение (через запятую)
																if(Core_Type_Conversion::toInt($item_row['shop_items_catalog_modification_id']) != 0)
																{
																	if(mb_strpos(mb_strtoupper($prop_row['shop_list_of_properties_cml_id']), "MOD_NAME_") === 0)
																	{
																		$new_item_name_array[] = $prop_row['shop_list_of_properties_name'] . " " . html_entity_decode($property_value, ENT_COMPAT, 'UTF-8');
																	}
																}
															}

															$item_extra_properties_array[$property_cml_id]['property_name'] = $property_name;
															$item_extra_properties_array[$property_cml_id]['property_cml_value'] = "";
														}
													}

													if(count($new_item_name_array) > 0)
													{
														$new_item_name = implode(", ", $new_item_name_array);

														if(defined('EXCLUDE_BASE_NAME_FROM_MODIFICATIONS') && EXCLUDE_BASE_NAME_FROM_MODIFICATIONS)
														{
															$item_name = $new_item_name;
														}
														else
														{
															$item_name = $item_row['shop_items_catalog_name'] . " " . $new_item_name;
														}

														// Обновляем информацию о названии товара
														$shop->InsertItem(array(
														'item_id' => $item_row['shop_items_catalog_item_id'],
														'name' => $item_name,
														'search_event_indexation' => false));
													}

													// Картинка
													// Товар был вставлен - нам известен его id
													if (isset($param['catalog_image'])
													&& count($param['catalog_image']) > 0
													&& $iNewItemId && $iNewItemId != -1)
													{
														$Image = & singleton('Image');

														// Первое (если их несколько) изображение импортируется как и импортировалось
														$catalog_image = $param['catalog_image'][0]['image_path'];

														/* $catalog_image_fullpath = realpath(CMS_FOLDER . $images_path . dirname($catalog_image)) . "/";
														$catalog_image_fullpath .= basename($catalog_image);

														$catalog_image_fullpath = $kernel->Utf8ToWindows1251($catalog_image_fullpath); */

														$catalog_image_fullpath = $shop->GetRealPath($images_path . $catalog_image);

														// Проверяем наличие файла изображения для товара
														if (!empty ($catalog_image) && file_exists($catalog_image_fullpath)
														|| mb_strpos(mb_strtolower($catalog_image), 'http://') === 0
														|| mb_strpos(mb_strtolower($images_path), 'http://') === 0)
														{
															// Копируем файл
															// WARNING! copy() не используем, т.к. в качестве пути к файлу может быть указан url
															if (mb_strpos(mb_strtolower($catalog_image), 'http://') === 0)
															{
																// Загружаем файл с внешнего сервера
																$filecontent = @ file_get_contents($catalog_image);
															}
															elseif (mb_strpos(mb_strtolower($images_path), 'http://') === 0)
															{
																// Загружаем файл с внешнего сервера
																$filecontent = @ file_get_contents($images_path . $catalog_image);
															}
															else
															{
																$filecontent = @ file_get_contents($catalog_image_fullpath);
															}

															$uploaddir = $shop->GetItemDir($iNewItemId);

															$kernel->PathMkdir($uploaddir);

															$uploaddir = CMS_FOLDER . $uploaddir;

															if ($filecontent)
															{
																// Необходимо удалить старые файлы
																if(!isset($item_row))
																{
																	$item_row = $shop->GetItem($iNewItemId);
																}

																$old_big_file = $uploaddir . $item_row['shop_items_catalog_image'];

																$old_small_file = $uploaddir . 'small_' . $item_row['shop_items_catalog_image'];

																if(file_exists($old_big_file))
																{
																	@unlink($old_big_file);
																}

																if(file_exists($old_small_file))
																{
																	@unlink($old_small_file);
																}

																// Определяем расширение файла
																$exp = $kernel->GetExtension($catalog_image);

																// Получаем данные о магазине
																$row_shop = $shop->GetShop($shop_shops_id);

																if(Core_Type_Conversion::toInt($row_shop['shop_shops_file_name_conversion']) == 1)
																{
																	// Имя нового файла
																	$shop_items_catalog_image = 'shop_items_catalog_image' . $iNewItemId . '.' . $exp;
																}
																else
																{
																	$shop_items_catalog_image = basename($catalog_image);
																}

																if ($fp_img = fopen($uploaddir . $shop_items_catalog_image, 'w'))
																{
																	fwrite($fp_img, $filecontent);
																	fclose($fp_img);
																	@ chmod($uploaddir . $shop_items_catalog_image, CHMOD_FILE);

																	if (!$Image->ResizeToFileEx($uploaddir . $shop_items_catalog_image, Core_Type_Conversion::toInt($row_shop['shop_image_big_max_width']), Core_Type_Conversion::toInt($row_shop['shop_image_big_max_height']), $uploaddir .
																	$shop_items_catalog_image))
																	{
																		show_error_message($GLOBALS['MSG_shops']['error_setup_picture']);
																	}

																	// Устанавливаем права доступа к файлу
																	@ chmod($uploaddir . $shop_items_catalog_image, CHMOD_FILE);

																	// Если не передан флаг ватермарка для маленькой картинки - то копируем ее до наложения ватермарка
																	if (!$row_shop['shop_watermark_default_use_small'])
																	{
																		// Делаем уменьшенный файл
																		if (!$Image->ResizeToFileEx($uploaddir . $shop_items_catalog_image, Core_Type_Conversion::toInt($row_shop['shop_image_small_max_width']), Core_Type_Conversion::toInt($row_shop['shop_image_small_max_height']), $uploaddir .
												"small_" . $shop_items_catalog_image))
																		{
																			show_error_message($GLOBALS['MSG_shops']['error_setup_picture']);
																		}

																		// Устанавливаем права доступа к файлу малой картинки
																		@ chmod($uploaddir . "small_" . $shop_items_catalog_image, CHMOD_FILE);
																	}

																	// Накладываем Watermark
																	if ($row_shop['shop_watermark_default_use_big'])
																	{
																		// Определяем путь к watermark'у
																		$watermark_uploaddir = $shop->CreateDirectory($shop_shops_id, "watermarks");

																		// Получаем путь к watermark файлу
																		if ($row_shop && $watermark_uploaddir)
																		{
																			$watermark_file = Core_Type_Conversion::toStr($row_shop['shop_watermark_file']);
																		}
																		else
																		{
																			$watermark_file = '';
																		}

																		// Если указан ватермарк для магазина
																		if (!empty ($watermark_file))
																		{
																			$watermark_file = $watermark_uploaddir . $watermark_file;
																			$result = $Image->CopyImgWithWatermark($uploaddir . $shop_items_catalog_image, $uploaddir .
																			$shop_items_catalog_image, $watermark_file, Core_Type_Conversion::toStr($row_shop['shop_watermark_default_position_x']), Core_Type_Conversion::toStr($row_shop['shop_watermark_default_position_y']));

																			if (!$result)
																			{
																				show_error_message($GLOBALS['MSG_shops']['items_add_form_image_watermark_apply_error']);
																			}
																		}
																	}

																	// Если  передан флаг ватермарка для маленькой картинки - то копируем ее после наложения ватермарка
																	if ($row_shop['shop_watermark_default_use_small'])
																	{
																		// Делаем уменьшенный файл
																		if (!$Image->ResizeToFileEx($uploaddir . $shop_items_catalog_image, Core_Type_Conversion::toInt($row_shop['shop_image_small_max_width']), Core_Type_Conversion::toInt($row_shop['shop_image_small_max_height']), $uploaddir .
												"small_" . $shop_items_catalog_image))
																		{
																			show_error_message($GLOBALS['MSG_shops']['error_setup_picture']);
																		}

																		// Устанавливаем права доступа к файлу малой картинки
																		@ chmod($uploaddir . "small_" . $shop_items_catalog_image, CHMOD_FILE);
																	}

																	// Делаем уменьшенный файл
																	if (!$Image->ResizeToFileEx($uploaddir . $shop_items_catalog_image, Core_Type_Conversion::toInt($row_shop['shop_image_small_max_width']), Core_Type_Conversion::toInt($row_shop['shop_image_small_max_height']), $uploaddir . "small_" . $shop_items_catalog_image))
																	{
																		show_error_message($GLOBALS['MSG_shops']['error_setup_picture']);
																	}

																	// Устанавливаем права доступа к файлу малой картинки
																	@ chmod($uploaddir . "small_" . $shop_items_catalog_image, CHMOD_FILE);

																	// Обновляем картинку для элемнта, если не пустое имя картинки, или указано обновлять картинки на пустые
																	if (!empty ($shop_items_catalog_image))
																	{
																		// Обновляем информацию об изображении для товара.
																		//$shop->UpdateImageForItem($shop_shops_id, $iNewItemId, $shop_items_catalog_image);

																		$query = "UPDATE `shop_items_catalog_table` SET `shop_items_catalog_image`='$shop_items_catalog_image', `shop_items_catalog_small_image`='small_$shop_items_catalog_image' WHERE `shop_items_catalog_item_id`='$iNewItemId'";

																		$DataBase->query($query);
																	}
																}
															}
															else
															{
																if ($import_price_list_action_delete_image)
																{
																	// Обновляем информацию об изображении для товара.
																	//$shop->UpdateImageForItem($shop_shops_id, $iNewItemId, '');
																	$query = "UPDATE `shop_items_catalog_table` SET `shop_items_catalog_image`='', `shop_items_catalog_small_image`='' WHERE `shop_items_catalog_item_id`='$iNewItemId'";

																	if($DataBase->query($query))
																	{
																		// Необходимо удалить файлы
																		if(Core_Type_Conversion::toInt($row_shop['shop_shops_file_name_conversion']) == 1)
																		{
																			// Имя нового файла
																			$shop_items_catalog_image = 'shop_items_catalog_image' . $iNewItemId . '.' . $exp;
																		}
																		else
																		{
																			$shop_items_catalog_image = basename($catalog_image);
																		}

																		if(file_exists($uploaddir . $shop_items_catalog_image))
																		{
																			@unlink($uploaddir . $shop_items_catalog_image);
																		}

																		if(file_exists($uploaddir . 'small_' . $shop_items_catalog_image))
																		{
																			@unlink($uploaddir . 'small_' . $shop_items_catalog_image);
																		}
																	}
																}
																show_error_message(sprintf($GLOBALS['MSG_shops']['error_load_file'], $filecontent));
															}
														}

														// Удаляем основное изображение
														unset($param['catalog_image'][0]);

														// Если в массиве еще остались изображения, необходимо их импортировать в качестве дополнительных свойств.
														if(count($param['catalog_image']) > 0)
														{
															foreach($param['catalog_image'] as $image_property_data)
															{
																// Проверяем, существует ли дополнительное свойство с идентификатором $image_property_data['image_property_cml_id'] в БД, если существует, обновляем его, иначе добавляем новое допсвойство
																// Проверяем на наличие двух GUIDов и символа "_"
																if(mb_strlen(basename($image_property_data['image_path'], '.' . $kernel->GetExtension($image_property_data['image_path']))) != 73)
																{
																	$property_image_cml_id = $image_property_data['image_property_cml_id'];
																}
																else
																{
																	// Получаем CML_ID дополнительного свойства типа "Файл"
																	$property_image_cml_id_string = basename($image_property_data['image_path'], '.' . $kernel->GetExtension($image_property_data['image_path']));


																	$property_image_cml_id_string = explode("_", $property_image_cml_id_string);

																	// Получили CML_ID
																	$property_image_cml_id = $property_image_cml_id_string[1];
																}

																if($property_row = $shop->GetItemPropertyIdByCmlId($property_image_cml_id, $shop_shops_id))
																{
																	$property_image_id = $property_row['shop_list_of_properties_id'];

																	if(Core_Type_Conversion::toInt($property_row['shop_list_of_properties_type']) != 1)
																	{
																		// Если тип свойства - не файл, сделаем его файлом!
																		$sql = "UPDATE `shop_list_of_properties_table` SET `shop_list_of_properties_type`='1' WHERE `shop_list_of_properties_id`='$property_image_id'";

																		$DataBase->query($sql);
																	}
																}
																else
																{
																	$url = & singleton('url');

																 	$property_image_id = $shop->InsertPropretyOfItems(array(
																	'shop_shops_id' => $shop_shops_id,
																	'name' => $image_property_data['image_property_cml_id'],
																	'xml_name' =>
			$property_of_items_xml_name = $url->translit_lower($image_property_data['image_property_cml_id']).time(),
																	'type' => 1,
																	'shop_list_of_properties_cml_id' => $property_image_cml_id,
																	'shop_shops_id' => $shop_shops_id
																	));
																}

																// Получаем информацию о группе товара
																$current_item_row = $shop->GetItem($iNewItemId);

																// Проверяем, доступно ли данное дополнительное свойство группе товаров данного товара ($param['groups_id'])
																if(!$shop->IssetPropertyForGroup(array(
																'shop_groups_id' => $current_item_row['shop_groups_id'],
																'shop_list_of_properties_id' => $property_image_id,
																'shop_shops_id' => $shop_shops_id
																)))
																{
																	// Свойство не доступно, делаем его доступным
																	$shop->InsertPropertyForGroup(array(
																	'shop_groups_id' => $current_item_row['shop_groups_id'],
																	'shop_list_of_properties_id' => $property_image_id,
																	'shop_shops_id' => $shop_shops_id
																	));
																}
																// Теперь у нас есть ID товара ($iNewItemId) и ID дополнительного свойства ($property_image_id), необходимо вставить значение дополнительного свойства для данного товара

																// Далее следует код вставки изображений для дополнительных свойств при ручной загрузке данных из CommerceML формата
																if(mb_strlen(basename($image_property_data['image_path'], '.' . $kernel->GetExtension($image_property_data['image_path']))) != 73 && is_file(CMS_FOLDER .$image_property_data['image_path']))
																{
																	$admin_load_files_array = array();

																	$admin_load_files_array['max_width_big_image'] = $row_shop['shop_image_big_max_width'];

																	$admin_load_files_array['max_height_big_image'] = $row_shop['shop_image_big_max_height'];

																	$admin_load_files_array['isset_big_image'] = 1;

																	$admin_load_files_array['path_source_big_image'] = CMS_FOLDER .$image_property_data['image_path'];

																	$basename = basename($image_property_data['image_path']);

																	$admin_load_files_array['original_file_name_big_image'] = $basename;

																	$item_dir = $shop->GetItemDir($iNewItemId);

																	$kernel->PathMkdir($item_dir);

																	// Если свойство уже существовало на момент импорта, могли остаться старые изображения, их необходимо удалить до загрузки новых
																	$property_row = $shop->GetValueItemProperty($iNewItemId, $property_image_id);
																	if($property_row)
																	{
																		$old_big_image_property = CMS_FOLDER . $item_dir . $property_row['shop_properties_items_file'];
																		$old_small_image_property = CMS_FOLDER . $item_dir . $property_row['shop_properties_items_file_small'];

																		if(is_file($old_big_image_property))
																		{
																			@unlink($old_big_image_property);
																		}

																		if(is_file($old_small_image_property))
																		{
																			@unlink($old_small_image_property);
																		}
																	}

																	$target_big_image_name = $basename;

																	$big_image_extension = mb_strtolower($kernel->GetExtension($target_big_image_name));
																	if($big_image_extension != '')
																	{
																		$big_image_extension = "." . $big_image_extension;
																	}

																	if(Core_Type_Conversion::toInt($row_shop['shop_shops_file_name_conversion']))
																	{
																		// Необходимо генерировать имя файла динамически
																		$target_big_image_name = "shop_property_file_" . $iNewItemId . "_" . $property_image_id . $big_image_extension;
																	}

																	$target_small_image_name = "small_" . $target_big_image_name;

																	$admin_load_files_array['path_target_big_image'] = CMS_FOLDER . $item_dir . $target_big_image_name;

																	$admin_load_files_array['max_width_small_image'] = $row_shop['shop_image_small_max_width'];
																	$admin_load_files_array['max_height_small_image'] = $row_shop['shop_image_small_max_height'];


																	$admin_load_files_array['watermark_file_path'] = CMS_FOLDER . UPLOADDIR . "shop_" . $shop_shops_id . "/watermarks/" . $row_shop['shop_watermark_file'];

																	$admin_load_files_array['used_watermark_big_image'] = $row_shop['shop_watermark_default_use_big'];
																	$admin_load_files_array['used_watermark_small_image'] = $row_shop['shop_watermark_default_use_small'];

																	$admin_load_files_array['watermark_position_x'] = $row_shop['shop_watermark_default_position_x'];
																	$admin_load_files_array['watermark_position_y'] = $row_shop['shop_watermark_default_position_y'];

																	$admin_load_files_array['use_big_image'] = 1;

																	$admin_load_files_array['path_source_small_image'] = $admin_load_files_array['path_source_big_image'];

																	$admin_load_files_array['path_target_small_image'] = CMS_FOLDER . $item_dir . $target_small_image_name;

																	$admin_load_files_array['original_file_name_small_image'] = $basename;

																	$result_download_files = $kernel->AdminLoadFiles($admin_load_files_array);

																	if($result_download_files['big_image'] && $result_download_files['small_image'])
																	{
																		// Добавляем информацию в БД
																		$shop->InsertPropertiesItem(array(
																		'shop_items_catalog_item_id' => $iNewItemId,
																		'shop_list_of_properties_id' => $property_image_id,
																		'shop_properties_items_value' => $basename,
																		'shop_properties_items_value_small' => $basename,
																		'shop_properties_items_file' => $target_big_image_name,
																		'shop_properties_items_file_small' => $target_small_image_name
																		));
																	}
																}
															}
														}
													}
												}
											}

											// УБРАНО!
											if(0)
											{
												 // Обработка значений свойств для товара
												 if (isset($c_metadata['children']))
												 {
												 $property_array = array();
												 foreach ($c_metadata['children'] as $property_id => $property_data)
												 {
												 if (isset($property_data['name'])
												 && $property_data['name'] == 'ЗначениеСвойства')
												 {
												 if (!empty($property_data['attr']['Значение']))
												 {
												 // Значения могут быть множественными, поэтому ниже мы им сделаем implode
												 $property_array[$property_data['attr']['ИдентификаторСвойства']][] = $property_data['attr']['Значение'];
												 }
												 }

												 if (count($property_array) > 0)
												 {
												 foreach ($property_array as $property_cml_id => $property_value_array)
												 {
												 $value_property = implode(', ', $property_value_array);

												 $item_row = $shop->GetCatalogItemIdByCmlId($c_metadata['attr']['Идентификатор'], $shop_shops_id);

												 // Импорт свойств с ID = 0 (описание и текст товара)
												 if ($property_cml_id == 0)
												 {
												 $data_counter = 0;

												 foreach ($c_metadata['children'] as $data_store_id => $data_store)
												 {
												 if ($data_store['attr']['ИдентификаторСвойства'] == 0)
												 {
												 if ($data_counter == 0)
												 {
												 // Обновляем основное свойство "Описание"
												 $data_counter++;

												 $shop->InsertItem(array('shops_id' => $shop_shops_id,
												 'item_id' => $item_row['shop_items_catalog_item_id'],
												 'description' => $data_store['attr']['Значение'],
												 'search_event_indexation' => false));
												 }
												 else
												 {
												 // Обновляем основное свойство "Текст"
												 $data_counter = 0;

												 $shop->InsertItem(array('shops_id' => $shop_shops_id,
												 'item_id' => $item_row['shop_items_catalog_item_id'],
												 'text' => $data_store['attr']['Значение'],
												 'search_event_indexation' => false));
												 }
												 }
												 }
												 }

												 // Если найден товар для дополнительного свойства
												 if ($item_row)
												 {
												 // Исли найдено свойство для его значения
												 if ($prop_row = $shop->GetItemPropertyIdByCmlId($property_cml_id, $shop_shops_id))
												 {
												 // Сохраняем значение свойства
												 $shop->InsertPropertiesItem(
												 array('shop_items_catalog_item_id' => $item_row['shop_items_catalog_item_id'],
												 'shop_list_of_properties_id' => $prop_row['shop_list_of_properties_id'],
												 'shop_properties_items_value' => $value_property));

												 // Если дополнительное свойство не доступно группе товаров, включаем доступность данного свойства данной группе товаров
												 if (!$shop->IssetPropertyForGroup(
												 array('shop_groups_id' => $item_row['shop_groups_id'],
												 'shop_list_of_properties_id' => $prop_row['shop_list_of_properties_id'],
												 'shop_shops_id' => $shop_shops_id)))
												 {
												 $shop->InsertPropertyForGroup(array('shop_groups_id' => $item_row['shop_groups_id'], 'shop_list_of_properties_id' => $prop_row['shop_list_of_properties_id'], 'shop_shops_id' => $shop_shops_id));
												 }

												 }
												 }
												 }
												 }
												 }
												 }
											}
										}
									}
								}
							}
						}
					}

					// Работаем с заказами
					if (isset($metadata['name'])
					&& $metadata['name'] == 'Документ' && isset($metadata['children']))
					{
						foreach($metadata['children'] as $order_data)
						{
							if(isset($order_data['name'])
							&& $order_data['name'] == 'Ид' && isset($order_data['value']))
							{
								// Обнаружен GUID заказа
								$order_guid = $order_data['value'];

								// Ищем заказ с таким GUID
								$order_row = $shop->GetOrderByGuid($order_guid);

								// Если заказ найден, обновляем его
								if($order_row)
								{
									// Идентификатор заказа
									$order_id = $order_row['shop_order_id'];

									$order_shop_shops_id = $order_row['shop_shops_id'];

									if(isset($order_data['Валюта']))
									{
										$currency_name = $order_data['Валюта'];

										// Ищем валюту с таким именем в магазине
										$currency_row = $shop->GetCurrencyByLike($currency_name);

										if($currency_row)
										{
											// Валюта найдена, берем ее ID
											$currency_id = $currency_row['shop_currency_id'];

											// Получаем коэффициент пересчета цены для каждого товара
											$currency_course = Core_Type_Conversion::toFloat($currency_row['shop_currency_value_in_basic_currency']);
										}
										else
										{
											// Валюта не найдена, вставляем ее

											// Передан ли курс валюты по отношению к базовой? (За базовую валюту всегда считается базовая валюта магазина)
											if(isset($order_data['Курс']))
											{
												$currency_course = Core_Type_Conversion::toFloat($order_data['Курс']);

												// Если курс передан и равен 1
												if(intval($currency_course) == 1)
												{
													// У нас не может быть двух базовых валют
													$currency_course = 0.0;
												}
											}
											else
											{
												// Курс не передан, ставим 0
												$currency_course = 0.0;
											}

											$currency_id = $shop->InsertCurrency(array(
											'name' => $currency_name,
											'currency_international_name' => $currency_name,
											'value_in_basic_currency' => $currency_course,
											'is_default' => 0
											));
										}

										// Необходимо получить коэффициент перерасчета из переданной валюты в валюту найденного заказа
										$koeff = $shop->GetCurrencyCoefficientToShopCurrency($currency_id, $order_row['shop_currency_id']);
									}
								}
							}

							/* сумму пока игнорируем // Получаем сумму заказа для проверки при пересчете далее
							if(isset($order_data['name'])
							&& $order_data['name'] == 'Ид'
							&& isset($order_data['value'])
							&& $order_row)
							{
								$order_summ_from_1c = $order_data['value'];
							}*/

							// Получаем данные о заказчике
							if(isset($order_data['name'])
							&& $order_data['name'] == 'Контрагенты'
							&& isset($order_data['children'])
							&& $order_row)
							{
								//$order_summ_from_1c = $order_data['value'];
								foreach($order_data['children'] as $users_data)
								{
									if(isset($users_data['children']))
									{
										foreach($users_data['children'] as $user_data)
										{
											if(isset($user_data['name'])
											&& $user_data['name'] == 'Контрагент'
											&& isset($user_data['children']))
											{
												foreach($user_data['children'] as $user_row)
												{
													if(isset($user_row['name'])
													&& $user_row['name'] == 'Наименование'
													&& isset($user_row['value']))
													{
														// Получили имя/фамилию пользователя
														$user_name = $user_row['value'];
													}
												}
											}
										}
									}
								}
							}

							if(isset($order_data['name'])
							&& $order_data['name'] == 'Комментарий'
							&& isset($order_data['value'])
							&& $order_row)
							{
								// Получаем комментарий к заказу
								$order_comment = quote_smart($order_data['value']);
							}

							// На момент написания кода информацию о налогах решено было пропустить

							// Получаем информацию о товарах заказа
							if(isset($order_data['name'])
							&& $order_data['name'] == 'Товары'
							&& isset($order_data['children'])
							&& $order_row)
							{
								foreach($order_data['children'] as $items_data)
								{
									if($items_data['name'] == 'Товар'
									&& isset($items_data['children']))
									{
										foreach($items_data['children'] as $item_data)
										{
											if(isset($item_data['name'])
											&& $item_data['name'] == 'Наименование'
											&& isset($item_data['value']))
											{
												// Получаем наименование товара
												$order_item_name = quote_smart($item_data['value']);
											}

											// Получаем информацию о товаре
											if(isset($item_data['name'])
											&& $item_data['name'] == 'Ид'
											&& isset($item_data['value']))
											{
												$item_guid = $item_data['value'];

												// Ищем данный товар в каталоге товаров по идентификатору CommerceML
												$item_data = $shop->GetItemByParam(array(
												'shop_items_cml_id' => $item_guid,
												'shop_shops_id' => $shop_shops_id
												));

												if($item_data)
												{
													$item_data_row = mysql_fetch_assoc($item_data);

													// Получаем идентификатор товара
													$item_id = $item_data_row['shop_items_catalog_item_id'];

													// Ищем товар в заказе
													$order_item_data = $shop->GetOrderItem($item_id);

													if($order_item_data)
													{
														// Товар в заказе найден, товар подтвержден, получаем его идентификатор
														$order_item_id = $order_item_data['shop_order_items_id'];
													}
												}
											}
											/* elseif(isset($item_data['name'])
											&& $item_data['name'] == 'Ид')
											{
												// Если же товар передан, но у него отсутствует CML_ID, необходимо добавить товар в базу с новым CML_ID
												$item_guid = $kernel->Guid();

												$item_id = $shop->InsertItem(
													array(
													'shops_id' => $shop_shops_id,
													'name' => '',
													'shop_items_cml_id' => $item_guid
													)
												);
											} */

											// Цена за единицу товара
											if(isset($item_data['name'])
											&& $item_data['name'] == 'ЦенаЗаЕдиницу'
											&& isset($item_data['value']))
											{
												$price_for_one_item = Core_Type_Conversion::toFloat($item_data['value']);
											}

											// Количество
											if(isset($item_data['name'])
											&& $item_data['name'] == 'Количество'
											&& isset($item_data['value']))
											{
												$item_count = Core_Type_Conversion::toFloat($item_data['value']);
											}

											// Если товар в заказе обнаружен, обновляем информацию о нем
											if(isset($order_item_id) && $order_item_id > 0)
											{
												// Получаем данные о товаре заказа
												$order_item_row = $shop->GetOrderItems($order_item_id);

												if(isset($order_item_name))
												{
													$order_item_row['shop_order_items_name'] = $order_item_name;
												}

												if(isset($price_for_one_item))
												{
													$order_item_row['shop_order_items_price'] = $price_for_one_item;
												}

												if(isset($item_count))
												{
													$order_item_row['shop_order_items_quantity'] = $item_count;
												}

												// Обновляем информацию о найденном товаре в заказе
												$shop->InsertOrderItems($order_item_row);
											}
											else
											{
												// Добавляем товар в заказ без привязки к какому-либо реальному товару из каталога
												$order_item_array = array();

												// Товар не найден по GUID среди каталога, либо его там просто нет, либо мы добавляли этот товар в заказ без привязки к каталогу. Ищем среди товаров заказа товар со значением первичного ключа каталога равного 0 и переданным нам именем. Ежели таковых товаров будет боле одного, считаем что мы ничего не нашли
												if(isset($order_item_name))
												{
													$query = "SELECT * FROM `shop_order_items_table`
													WHERE `shop_items_catalog_item_id`='0'
													AND `shop_order_items_name`='{$order_item_name}'
													AND `shop_order_id`='$order_id'";

													$order_item_res = $DataBase->query($query);

													if($order_item_res && mysql_num_rows($order_item_res) == 1)
													{
														$order_item_row = mysql_fetch_assoc($order_item_res);

														$order_item_array['shop_order_items_id'] = $order_item_row['shop_order_items_id'];
													}
												}

												if(isset($order_item_name))
												{
													$order_item_array['shop_order_items_name'] = $order_item_name;
												}
												else
												{
													$order_item_array['shop_order_items_name'] = '';
												}

												if(isset($price_for_one_item))
												{
													// Необходимо пересчитать цену товара из валюты товара в валюту заказа
													if(isset($koeff))
													{
														$price_for_one_item = $price_for_one_item * $koeff;
													}

													$order_item_array['shop_order_items_price'] = $price_for_one_item;
												}

												if(isset($item_count))
												{
													$order_item_array['shop_order_items_quantity'] = $item_count;
												}

												$order_item_array['shop_order_id'] = $order_id;

												// Не связываем данный товар с реальными товарами из каталога магазина
												$order_item_array['shop_items_catalog_item_id'] = 0;

												if($order_item_array['shop_order_items_name'] != '')
												{
													$shop->InsertOrderItems($order_item_array);
												}
											}
										}
									}
								}
							}

							// Получаем информацию о значениях реквизитов заказа
							if(isset($order_data['name'])
							&& $order_data['name'] == 'ЗначенияРеквизитов'
							&& isset($order_data['children'])
							&& $order_row)
							{
								foreach($order_data['children'] as $options_data)
								{
									if(isset($options_data['name'])
									&& $options_data['name'] == 'ЗначениеРеквизита'
									&& isset($options_data['children']))
									{
										foreach($options_data['children'] as $option_data)
										{
											if(isset($option_data['name'])
											&& $option_data['name'] == 'Наименование'
											&& isset($option_data['value'])
											&& $option_data['value'] == 'Проведен')
											{
												// Обнаружили флаг статуса заказа, создаем переменную для его хранения
												$order_status_flag = 0;
											}

											if(isset($option_data['name'])
											&& $option_data['name'] == 'Значение'
											&& isset($option_data['value'])
											&& isset($order_status_flag))
											{
												$order_status_flag = (($option_data['value'] == 'true')?1:0);
											}
										}
									}
								}
							}
						}

						// Если заказ найден, обновляем информацию о нем
						if(isset($order_id))
						{
							$order_param = array();

							$order_param['id'] = $order_id;

							$order_param['shop_shops_id'] = $order_shop_shops_id;

							// Статус заказа
							if(isset($order_status_flag))
							{
								$order_param['status_of_pay'] = $order_status_flag;
							}

							if(isset($order_comment))
							{
								$order_param['description'] = $order_comment;
							}

							if(isset($user_name))
							{
								$order_param['shop_order_users_name'] = $user_name;
							}

							if(isset($currency_id))
							{
								$order_param['currency_id'] = $currency_id;
							}

							$shop->InsertOrder($order_param);

							unset($order_id);
						}
					}

					// Работаем с пакетом предложений
					if (isset($metadata['name'])
					&& $metadata['name'] == 'ПакетПредложений'
					&& isset($metadata['children']))
					{
						// Текущий тип цены
						$current_type_of_price = 0;

						foreach ($metadata['children'] as $thinking_id => $thinking_data)
						{
							if (isset($thinking_data['name'])
							&& $thinking_data['name'] == 'Предложение'
							&& isset($thinking_data['attr']))
							{

								$currency_name = false;

								// Если найден товар по идентификатору CML - обновляем данные для него
								if (isset($thinking_data['attr']['ИдентификаторТовара'])
								&& $item_rows = $shop->GetCatalogItemIdByCmlId($thinking_data['attr']['ИдентификаторТовара'], $shop_shops_id))
								{
									if (isset($thinking_data['attr']['Валюта']))
									{
										$currency_name = $thinking_data['attr']['Валюта'];
									}
									else
									{
										foreach ($thinking_data['children'] as $children_number => $children_metadata)
										{
											if ($children_metadata['name'] == 'Валюта')
											{
												$currency_name = $children_metadata['value'];
											}
										}
									}

									if ($currency_name)
									{
										// Обрабатываем валюту
										if ($currency_array = $shop->GetCurrencyByLike($currency_name))
										{
											if($currency_array && isset($currency_array[0]) && isset($currency_array[0]['shop_currency_id']))
											{
												$currency_international_id = $currency_array[0]['shop_currency_id'];
											}
											else
											{
												$currency_international_id = 0;
											}
										}
										else
										{
											$currency_international_id = $shop->InsertCurrency(
											array('name' => $currency_name,
											'currency_international_name' => $currency_name,
											'value_in_basic_currency' => 0));
										}
									}
									else
									{
										$currency_international_id = 0;
									}

									if($current_type_of_price == 0)
									{
										// Обновляем информацию о товаре
										$item_id_new = $shop->InsertItem(array('shops_id' => $shop_shops_id,
										'item_id' => $item_rows['shop_items_catalog_item_id'],
										'price' => Core_Type_Conversion::toFloat($thinking_data['attr']['Цена']),
										'currency_id' => $currency_international_id,
										'search_event_indexation' => false));
									}
									else
									{
										// Необходимо вставить значение цены для товара
										$shop->InsertPricesToItem(array(
											'shop_items_catalog_item_id' => $item_rows['shop_items_catalog_item_id'],
											'shop_list_of_prices_id' => $current_type_of_price,
											'shop_prices_to_item_value' => Core_Type_Conversion::toFloat($thinking_data['attr']['Цена'])
										));

										$item_id_new = $item_rows['shop_items_catalog_item_id'];
									}

									$warehouse = & singleton('warehouse');

									// Получаем склад по умолчанию
									$warehouse_row = $warehouse->GetDefaultWarehouse($shop_shops_id);

									if($warehouse_row)
									{
										$warehouse->InsertWarehouseItems(array(
											'shop_warehouse_id' => $warehouse_row['shop_warehouse_id'],
											'shop_items_catalog_item_id' => $item_id_new,
											'shop_warehouse_items_count' => Core_Type_Conversion::toInt($thinking_data['attr']['Количество'])
										));
									}
								}
							}
							elseif(isset($thinking_data['name'])
							&& $thinking_data['name'] == 'ЗначениеСвойства'
							&& isset($thinking_data['attr']))
							{
								// Получаем идентификатор свойства товара
								$property_id = $thinking_data['attr']['ИдентификаторСвойства'];

								if(isset($array_of_type_of_prices_1v) && isset($array_of_type_of_prices_1v[$property_id]) && $array_of_type_of_prices_1v[$property_id] == 'Тип цены')
								{
									// Нам передан тип цены, ищем его среди типов цены магазина, только если это не розничная цена
									if($thinking_data['attr']['Значение'] != 'Розничная')
									{
										$price_name = quote_smart($thinking_data['attr']['Значение']);

										$sql = "SELECT * FROM `shop_list_of_prices_table` WHERE `shop_list_of_prices_name`='$price_name' AND `shop_shops_id`='$shop_shops_id'";

										$result = $DataBase->query($sql);

										if($result && mysql_num_rows($result) > 0)
										{
											$row = mysql_fetch_assoc($result);

											$current_type_of_price = $row['shop_list_of_prices_id'];
										}
										else
										{
											// Добавляем цену
											$current_type_of_price = $shop->InsertPrice(array(
												'shop_shops_id' => $shop_shops_id,
												'name' => $price_name,
												'percent_to_basic' => 0,
												'shop_list_of_prices_cml_id' => $kernel->guid()
											));
										}
									}
								}
								else
								{
									$current_type_of_price = 0;
								}
							}
						}
					}
				}
			}
		}

		// Формируем массив с данными о вставленных/обновленных товарах/группах товаров
		$return_array = array('count_insert_item' => $count_insert_item, 'count_update_item' => $count_update_item, 'count_dir' => $count_dir);

		return $return_array;
	}
}

?>