<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 * Properties.
 *
 * @package HostCMS 6\Property
 * @version 6.x
 * @author Hostmake LLC
 * @copyright © 2005-2012 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 */
class Property_Controller_Value
{
	static public function factory($type)
	{
		if (!is_numeric($type))
		{
			throw new Core_Exception('Unknown Property_Controller_Value type "%type"', array('%type' => $type));
		}
		$queryBuilderName = __CLASS__ . '_type' . ucfirst($type);
		return new $queryBuilderName();
	}
	
	/**
	 * Получение значений свойств $aProperiesId объекта $entityId
	 */
	static public function getPropertiesValues($aProperiesId, $entityId, $bCache = TRUE)
	{
		$aReturn = array();
		
		if (count($aProperiesId) > 0)
		{
			$aSelect = array();
			foreach ($aProperiesId as $iPropertyId)
			{
				$oProperty = Core_Entity::factory('Property', $iPropertyId);
				$aPropertyValue = self::factory($oProperty->type);
				$aSelect[$aPropertyValue->getModelName()][] = $iPropertyId;
			}
			
			// Вариант на UNION
			/*foreach($aSelect as $sModelName => $aTmpProperiesId)
			{
				$oProperty_Values = Core_Entity::factory($sModelName);

				$iFirstProperyId = array_shift($aTmpProperiesId);
				
				$oProperty_Values
					->queryBuilder()
					->where('property_id', '=', $iFirstProperyId)
					->where('entity_id', '=', $entityId);

				foreach ($aTmpProperiesId as $iTmpProperyId)
				{
					$queryBuilder = Core_QueryBuilder::select()
						->from(Core_Inflection::getPlural($sModelName))
						->where('property_id', '=', $iTmpProperyId)
						->where('entity_id', '=', $entityId);
						
					$oProperty_Values
						->queryBuilder()
						->union($queryBuilder);
				}
					
				$aReturn = array_merge($aReturn, $oProperty_Values->findAll());
			}*/
			
			foreach($aSelect as $sModelName => $aTmpProperiesId)
			{
				$oProperty_Values = Core_Entity::factory($sModelName);

				$oProperty_Values
					->queryBuilder()
					->where('entity_id', '=', $entityId)
					->where('property_id', 'IN', $aTmpProperiesId);

				$aReturn = array_merge($aReturn, $oProperty_Values->findAll($bCache));
			}
		}
		
		return $aReturn;
	}
}
