<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 * Properties.
 *
 * @package HostCMS 6\Property
 * @version 6.x
 * @author Hostmake LLC
 * @copyright © 2005-2012 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 */
class Property_Value_Int_Model extends Core_Entity
{
	/**
	 * Model name
	 * @var mixed
	 */
	protected $_modelName = 'property_value_int';

	/**
	 * Disable markDeleted()
	 * @var mixed
	 */
	protected $_marksDeleted = NULL;

	protected $_belongsTo = array(
		'property' => array(),
		'list_item' => array('foreign_key' => 'value'),
		'informationsystem_item' => array('foreign_key' => 'value'),
	);

	protected $_sorting = array(
		'property_value_ints.id' => 'ASC'
	);

	public function setValue($value)
	{
		$this->value = intval($value);
		return $this;
	}

	protected $_tagName = 'property_value';

	public function getXml()
	{
		$oProperty = $this->Property;

		$this->clearXmlTags()
			->addXmlTag('property_dir_id', $this->Property->property_dir_id)
			->addXmlTag('tag_name', $oProperty->tag_name);

		// List
		if ($oProperty->type == 3 && $this->value != 0 && Core::moduleIsActive('list'))
		{
			$this->addForbiddenTag('value');

			$oList_Item = $this->List_Item;

			if ($oList_Item->id)
			{
				$this
					->addXmlTag('value', $oList_Item->value)
					->addXmlTag('description', $oList_Item->description);
			}
		}
		
		// Informationsystem
		if ($oProperty->type == 5 && $this->value != 0 && Core::moduleIsActive('informationsystem'))
		{
			$this->addForbiddenTag('value');

			$oInformationsystem_Item = $this->Informationsystem_Item;
			$oInformationsystem_Item->id && $this->addEntity(
				$oInformationsystem_Item->clearEntities()
			);
		}

		return parent::getXml();
	}
}