<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 * Выбор адреса доставки.
 *
 * @package HostCMS 6\Shop
 * @version 6.x
 * @author Hostmake LLC
 * @copyright © 2005-2012 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 */
class Shop_Address_Controller_Show extends Core_Controller
{
	/**
	 * Allowed object properties
	 * @var array
	 */
	protected $_allowedProperties = array(
		'countries',
	);

	/**
	 * Constructor.
	 */
	public function __construct(Shop_Model $oShop)
	{
		parent::__construct($oShop->clearEntities());

		if (Core::moduleIsActive('siteuser'))
		{
			// Если есть модуль пользователей сайта, $siteuser_id равен 0 или ID авторизованного
			$oSiteuser = Core_Entity::factory('Siteuser')->getCurrent();
			if ($oSiteuser)
			{
				$this->addEntity($oSiteuser->clearEntities());
			}
		}

		$this->countries = TRUE;
	}

	/**
	 * Show built data
	 * @return Core_Controller
	 */
	public function show()
	{
		$oShop = $this->getEntity();

		$this->countries && $this->addEntities(
			Core_Entity::factory('Shop_Country')->findAll()
		);

		/*$this->addEntity(
			Core::factory('Core_Xml_Entity')
				->name('total_amount')
				->value($amount - $totalDiscount)
		);*/

		return parent::show();
	}
}