<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 * Online shop.
 *
 * @package HostCMS 6\Shop
 * @version 6.x
 * @author Hostmake LLC
 * @copyright © 2005-2012 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 */
class Shop_Order_Item_Controller_Edit extends Admin_Form_Action_Controller_Type_Edit
{
	public function setObject($object)
	{
		if (is_null($object->id))
		{
			$object->shop_order_id = Core_Array::getGet('shop_order_id');
		}
		
		$this->addSkipColumn('hash');
		$this->addSkipColumn('shop_item_digital_id');

		parent::setObject($object);

		$oMainTab = $this->getTab('main');
		$oAdditionalTab = $this->getTab('additional');
		$oSeparatorField = new Admin_Form_Entity_Separator();

		$oOrder = Core_Entity::factory('Shop_Order', intval(Core_Array::getGet('shop_order_id')));

		$this->getField('quantity')
			->style("width: 200px")
			->divAttr(array('style' => 'float: left'))
			->class("large");

		$oPriceField = $this->getField('price');

		$oPriceField
			->style("width: 200px")
			->class("large");

		$oAdditionalTab->delete
		(
			$this->getField('shop_warehouse_id')
		);

		$oWarehouseSelect = new Admin_Form_Entity_Select();

		$oWarehouseSelect->caption(Core::_('Shop_Order_Item.shop_warehouse_id'))
			->options(
				$this->_fillWarehousesList(Core_Array::getGet('shop_id'))
			)
			->name('shop_warehouse_id')
			->value($this->_object->shop_warehouse_id)
			->style("width: 200px")
			->divAttr(array('style' => 'float: left'));

		$oMainTab->addAfter(
			$oWarehouseSelect, $oPriceField
		);

		$oMainTab->delete
		(
			$this->getField('type')
		);

		$oTypeSelect = new Admin_Form_Entity_Select();

		$oTypeSelect->caption(Core::_('Shop_Order_Item.type'))
			->options(
				array(
					Core::_('Shop_Order_Item.order_item_type_caption0'),
					Core::_('Shop_Order_Item.order_item_type_caption1'),
					Core::_('Shop_Order_Item.order_item_type_caption2')
				)
			)
			->name('type')
			->value($this->_object->type)
			->style("width: 200px");

		$oMainTab->addAfter(
			$oTypeSelect, $oWarehouseSelect
		);

		$oMarkingField = $this->getField('marking');

		$oMarkingField
			->style("width: 200px")
			->divAttr(array('style' => 'float: left'));

		$this->getField('rate')->divAttr(array('style' => 'display: none'));
		//$this->getField('hash')->divAttr(array('style' => 'display: none'));
		//$this->getField('shop_item_digital_id')->divAttr(array('style' => 'display: none'));

		$oAdditionalTab
			->move($this->getField('shop_item_id')->style("width: 200px"), $oMainTab);

		$title = $this->_object->id
			? Core::_('Shop_Order_Item.order_items_edit_form_title', $oOrder->invoice)
			: Core::_('Shop_Order_Item.order_items_add_form_title', $oOrder->invoice);

		$this->title($title);

		return $this;
	}

	protected function _fillWarehousesList($iShopId)
	{
		$oObject = Core_Entity::factory('Shop_Warehouse');

		$oObject->queryBuilder()
				->where("shop_id", "=", $iShopId)
				->orderBy("sorting")
				->orderBy("id")
			;

		$aObjects = $oObject->findAll();

		$aReturn = array(" … ");

		foreach ($aObjects as $oObject)
		{
			$aReturn[$oObject->id] = $oObject->name;
		}

		return $aReturn;
	}
}