<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 * Filemanager.
 *
 * @package HostCMS 6\Wysiwyg
 * @version 6.x
 * @author Hostmake LLC
 * @copyright © 2005-2012 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 */
class Wysiwyg_Filemanager_File extends Core_Entity
{
	/**
	 * Model name
	 * @var mixed
	 */
	protected $_modelName = 'wysiwyg_filemanager';

	public $hash = NULL;
	public $name = NULL;
	public $type = NULL;
	public $datetime = NULL;
	public $size = NULL;
	public $mode = NULL;
	public $path = NULL;
	public $download = 0;

	protected function _loadColumns()
	{
		return $this;
	}

	protected $_sortField = NULL;
	public function setSortField($sortField)
	{
		$this->_sortField = $sortField;
	}

	public function getSortField()
	{
		return $this->_sortField;
	}

	public function getPrimaryKeyName()
	{
		return 'hash';
	}

	/**
	 * Delete object from database
	 * @param mixed $primaryKey primary key for deleting object
	 * @return Core_Entity
	 */
	public function delete($primaryKey = NULL)
	{
		$filePath = $this->path . DIRECTORY_SEPARATOR . Core_File::convertfileNameToLocalEncoding($this->name);

		$this->type == 'file'
			? Core_File::delete($filePath)
			: Core_File::deleteDir($filePath);

		return $this;
	}

	public function adminDownload()
	{
		if ($this->type == 'file')
		{
			ob_start();
			$oCore_Html_Entity_Img = Core::factory('Core_Html_Entity_A')
				->add(
					Core::factory('Core_Html_Entity_Img')
						->src('/admin/images/disk.gif')
				)
				->href("/admin/filemanager/index.php?hostcms[action]=download&cdir=" . rawurlencode(Core_File::pathCorrection(Core_Array::getRequest('cdir'))) ."&hostcms[checked][1][{$this->hash}]=1")
				//->target('_blank')
				->execute();
			return ob_get_clean();
		}
	}

	public function download()
	{
		/*$filePath = CMS_FOLDER . Core_File::pathCorrection(Core_Array::getRequest('cdir') . Core_File::convertfileNameToLocalEncoding($this->name));*/
		$filePath = $this->path . DIRECTORY_SEPARATOR . Core_File::convertfileNameToLocalEncoding($this->name);

		Core_File::download($filePath, $this->name, array('content_disposition' => 'attachment'));
		exit();
	}

	public function getTableColums()
	{
		return array_flip(
			array('hash', 'name', 'type', 'datetime', 'size', 'mode')
		);
	}

	public function image()
	{
		if ($this->type == 'file')
		{
			// Ассоциированные иконки
			$ext = Core_File::getExtension($this->name);

			$icon_file = '/admin/images/icons/' . (isset(Core::$mainConfig['fileIcons'][$ext]) ? Core::$mainConfig['fileIcons'][$ext] : 'file.gif');
		}
		else
		{
			$icon_file = $this->name == '..'
				? '/admin/images/top_point.gif'
				: '/admin/images/folder.gif';
		}

		?><img src="<?php echo $icon_file?>" /><?php
	}

	public function datetime()
	{
		return Core_Date::sql2datetime($this->datetime);
	}
}